

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\OutputForms.h"
#include "BaseTools\Color.h"
#include "private\vw_common_exports.h"


//********************************************************************
namespace vertexware {


//====================================================================
// Handles formatted output of colors.
//====================================================================
class VW_COMMON_API ColorOutputForm : public NumberSequenceOutputForm
{
VW_DECLARE_NUMBER_SEQUENCE_OUTPUT_FORM( ColorOutputForm )


public:
	//---------------
	// Bind to color.
	//---------------
	const NumberSequenceBoundOutputForm_float operator()(const color4f& c) const {
		return NumberSequenceBoundOutputForm_float(*this, c.ToPtr(), 4, 4);
	}
	const NumberSequenceBoundOutputForm_ubyte operator()(const color4b& c) const {
		return NumberSequenceBoundOutputForm_ubyte(*this, c.ToPtr(), 4, 4);
	}
};


//====================================================================
// Outputs the color using the current form.
//====================================================================
__forceinline std::ostream& __fastcall operator<<(std::ostream &os, const color4f& c)
{
	NumberSequenceBoundOutputForm_float
			boundForm(ColorOutputForm::GetCurrentOutputForm(), c.ToPtr(), 4, 4);
	return os << boundForm;
}


//====================================================================
__forceinline std::ostream& __fastcall operator<<(std::ostream &os, const color4b& c)
{
	NumberSequenceBoundOutputForm_ubyte
			boundForm(ColorOutputForm::GetCurrentOutputForm(), c.ToPtr(), 4, 4);
	return os << boundForm;
}


//********************************************************************
}//namespace vertexware

