

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\Types.h"
#include "private\vw_common_exports.h"
#include <string>


//********************************************************************
namespace vertexware {


//********************************************************************
namespace library_info {


//====================================================================
#define  VW_LIBRARY_VERSION_MAJOR      uint(1)
#define  VW_LIBRARY_VERSION_MINOR      uint(0)
#define  VW_LIBRARY_VERSION_REVISION   uint(0)


//====================================================================
#define  VW_LIBRARY_VERSION_BUILDTYPE_DEBUG     uint(1)
#define  VW_LIBRARY_VERSION_BUILDTYPE_RELEASE   uint(0)

#ifdef VW_BUILD_DEBUG
#define  VW_LIBRARY_VERSION_BUILDTYPE   VW_LIBRARY_VERSION_BUILDTYPE_DEBUG
#else
#define  VW_LIBRARY_VERSION_BUILDTYPE   VW_LIBRARY_VERSION_BUILDTYPE_RELEASE
#endif


//====================================================================
struct VW_COMMON_API LibraryVersion
{
	uint  major;
	uint  minor;
	uint  revision;
	uint  buildFlags;

	LibraryVersion(uint major = VW_LIBRARY_VERSION_MAJOR,
					uint minor = VW_LIBRARY_VERSION_MINOR,
					uint revision = VW_LIBRARY_VERSION_REVISION,
					uint buildFlags = VW_LIBRARY_VERSION_BUILDTYPE);

	bool  operator==(const LibraryVersion& rhs) const;
	bool  operator!=(const LibraryVersion& rhs) const { return !(*this == rhs); }

	bool  IsBuildTypeDebug() const;
	bool  IsBuildTypeRelease() const;

	std::string  MakeString() const;

	//--------------------------------------------------------
	// Requires exact match of: <major>, <minor>, <buildFlags>
	//--------------------------------------------------------
	bool  IsCompatibleWith(const LibraryVersion& rhs) const;
};


//====================================================================
#define  VW_BUILD_TIMESTAMP_STRING \
				(__DATE__ " / " __TIME__)


//====================================================================
VW_COMMON_API
LibraryVersion __fastcall GetLibraryVersion();


//====================================================================
VW_COMMON_API
std::string __fastcall GetBuildTimestamp();


//====================================================================
VW_COMMON_API
std::string __fastcall GetLibraryName();


//====================================================================
VW_COMMON_API
std::string __fastcall GetCopyrightNotice();


//====================================================================
VW_COMMON_API
uint __fastcall GetNumDevelopers();


//====================================================================
VW_COMMON_API
std::string __fastcall GetDeveloperInfo(uint i);


//********************************************************************
}//namespace library_info


//********************************************************************
}//namespace vertexware

