

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "Framework\Plugin.h"
#include "private\vw_common_exports.h"


//********************************************************************
namespace vertexware {


//====================================================================
// GenericExtension base-class.
//====================================================================
class VW_COMMON_API GenericExtension : public Plugin
{
public:
	virtual ~GenericExtension();

	//------------------------
	// Exceptions NOT allowed.
	//------------------------
	virtual  std::string  GetGenericExtensionInterfaceName() = 0;


protected:
	GenericExtension();
};


//====================================================================
class VW_COMMON_API GenericExtensionPluginDescriptor : public PluginDescriptor
{
public:
	virtual  Plugin*  CreatePlugin() {
		return CreateGenericExtension();
	}

	virtual  GenericExtension*  CreateGenericExtension() = 0;


protected:
	GenericExtensionPluginDescriptor(const PluginInfo& pi);
};


//====================================================================
// GenericExtension plugin access-point declaration.
//====================================================================
#define  VW_DECLARE_PLUGIN_ACCESS_POINT_GENERIC_EXTENSION( \
				ClassNamePlugin, StringPluginName, \
				UIntPluginVersionMajor, UIntPluginVersionMinor, \
				UIntPluginVersionRevision, UIntPluginVersionBuildFlags, \
				StringPluginDescription, StringPluginDeveloperInfo) \
\
struct ClassNamePlugin##__PluginDescriptor : public GenericExtensionPluginDescriptor \
{ \
	ClassNamePlugin##__PluginDescriptor() \
		: GenericExtensionPluginDescriptor(PluginInfo( \
				vertexware::library_info::LibraryVersion(), \
				PluginType_GenericExtension, \
				StringPluginName, \
				vertexware::PluginVersion(UIntPluginVersionMajor, UIntPluginVersionMinor, \
										UIntPluginVersionRevision, UIntPluginVersionBuildFlags), \
				VW_BUILD_TIMESTAMP_STRING, \
				StringPluginDescription, \
				StringPluginDeveloperInfo)) \
	{ } \
\
	virtual  GenericExtension*  CreateGenericExtension() { \
		return new ClassNamePlugin; \
	} \
}; \
VW_DECLARE_PLUGIN_ACCESS_POINT( ClassNamePlugin##__PluginDescriptor )


//********************************************************************
}//namespace vertexware


