

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "Framework\GenericExtension.h"
#include "private\vw_common_exports.h"


//********************************************************************
namespace vertexware {


//====================================================================
// dxerr8 static-library-wrapper.
//====================================================================
class VW_COMMON_API LibWrapperDXErr8 : public GenericExtension
{
public:
	// client interface
	static std::string __fastcall DXGetErrorDescription8(HRESULT hr);


public:
	//---------------------------------
	// GenericExtension implementation.
	//---------------------------------
	virtual  std::string  GetGenericExtensionInterfaceName();

	//----------------------------
	// LibWrapperDXErr8 interface.
	//----------------------------
	virtual  void  HookProcAddresses() = 0;
	void           InvalidateProcAddresses();


protected:
	typedef const char* (__stdcall *PFN_DXGetErrorDescription8)(HRESULT hr);

	void  SetProcAddresses(PFN_DXGetErrorDescription8 pfnDXGetErrorDescription8);


private:
	static  PFN_DXGetErrorDescription8  s_pfnDXGetErrorDescription8;
};


//====================================================================
#define  VW_INTERFACE_NAME_LibWrapperDXErr8   "LibWrapperDXErr8"


//********************************************************************
}//namespace vertexware


