

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "Framework\VideoRenderer.h"
#include "Framework\VideoSubsystemDirect3D8.h"
#include "private\vw_direct3d8_exports.h"
#include <d3d8.h>


//********************************************************************
namespace vertexware {


//====================================================================
// Direct3D8 direct-access interface.
//====================================================================
class VW_DIRECT3D8_API VideoRendererDirect3D8 : virtual public VideoRenderer
{
public:
	virtual ~VideoRendererDirect3D8();


	//---------------------------------
	// Direct3D8 root-interface access.
	//---------------------------------
	IDirect3D8*        GetD3DObject() { return pD3DObject; }
	IDirect3DDevice8*  GetD3DDevice() { return pD3DDevice; }


	//------------------------------
	// VideoRenderer implementation.
	//------------------------------
	virtual  std::string  GetVideoRendererInterfaceName();
	virtual  std::string  GetMatchingVideoSubsystemInterfaceName();


protected:
	VideoRendererDirect3D8();

	VideoSubsystemDirect3D8*  GetVideoSubsystemDirect3D8() { return pD3DVideoSubsystem; }

	//------------------------------
	// VideoRenderer implementation.
	//------------------------------
	virtual  void  ConnectVideoSubsystem(VideoSubsystem& vs);
	virtual  void  DisconnectVideoSubsystem();

	virtual  void  CreateVideoResources(bool bPostReset);
	virtual  void  ReleaseVideoResources(bool bPreReset);


private:
	VideoSubsystemDirect3D8*  pD3DVideoSubsystem;

	IDirect3D8*        pD3DObject;
	IDirect3DDevice8*  pD3DDevice;
};


//====================================================================
#define  VW_INTERFACE_NAME_VideoRendererDirect3D8   "VideoRendererDirect3D8"


//********************************************************************
}//namespace vertexware


