

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\Types.h"
#include "MathTools\Matrix44.h"
#include "MathTools\Vector3.h"
#include "private\vw_opengl_exports.h"
#include <gl\gl.h>


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gl_tools {


//====================================================================
// gluPerspective() replacement
//====================================================================
VW_OPENGL_API
void __fastcall Perspective(GLdouble fovYDeg, GLdouble aspectWToH, GLdouble zNear, GLdouble zFar);


//====================================================================
// Standard-RHS UVN to OpenGL-RHS UVN.
// Provide normalized-view-direction and view-position.
// Routine can also pre-concatenate matrix that compensates
// for OpenGL projection inversion. Calls glLoadMatrix() internally.
//====================================================================
VW_OPENGL_API
void __fastcall View(const vec3& rotation,
					const vec3& position = vec3::ZERO,
					bool bProjectionCompensation = true);


//====================================================================
VW_OPENGL_API __forceinline
void __fastcall View(float head, float pitch, float roll = 0,
					const vec3& position = vec3::ZERO,
					bool bProjectionCompensation = true)
{
	View(vec3(pitch, head, roll), position, bProjectionCompensation);
}


//********************************************************************
}//namespace gl_tools


//********************************************************************
}//namespace vertexware


