

//--------------------------------------------------------------------
#pragma once


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui {


//====================================================================
// Standard message identifiers
//====================================================================
enum eMessageID
{
	MID_Null = 0,

	MID_ServiceProviderChanged,
	MID_ServiceCommand,

	MID_Command,

	MID_GeometryUpdateByManager,
	MID_Activate,
	MID_Deactivate,

	MID_MouseCapture,
	MID_MouseEnterExit,
	MID_MouseQueryCursor,
	MID_MouseMove,
	MID_MouseWheel,
	MID_MouseButton,

	MID_KeyboardQueryFocus,
	MID_KeyboardFocus,
	MID_KeyboardKey,

	MID_TimeDelta,

	MID_Show,
	MID_ShowChildren,
	MID_ShowDescendants,
	MID_Enable,
	MID_Flags,
	MID_FlagsOnOff,
	MID_OnOff,
	MID_Select,
	MID_Scroll,
	MID_PreCommandExecute,
	MID_SendCommand,

	MID_User        = 0x10000000,
	MID_Force32Bits = 0x7FFFFFFF
};


//====================================================================
// Standard service identifiers
//====================================================================
enum eServiceID
{
	SID_Null = 0,

	SID_ToolTip,

	SID_User        = 0x10000000,
	SID_Force32Bits = 0x7FFFFFFF
};


//====================================================================
// Standard service-command identifiers
//====================================================================
enum eServiceCommandID
{
	SCID_Null = 0,

	SCID_Request,
	SCID_Reset,
	SCID_On,
	SCID_Off,
	SCID_QueryParams,

	SCID_User        = 0x10000000,
	SCID_Force32Bits = 0x7FFFFFFF
};


//====================================================================
// Standard command identifiers
//====================================================================
enum eCommandID
{
	CID_Null = 0,

	CID_ControlValuesChanged,
	CID_SendCommand,
	CID_Exit,
	CID_Minimize,
	CID_Maximize,
	CID_Restore,
	CID_Close,
	CID_Open,
	CID_Apply,
	CID_OK,
	CID_Forward,
	CID_Backward,
	CID_Center,
	CID_Left,
	CID_Right,
	CID_Up,
	CID_Down,
	CID_LeftUp,
	CID_LeftDown,
	CID_RightUp,
	CID_RightDown,
	CID_OnOff,
	CID_Selected,

	CID_User        = 0x10000000,
	CID_Force32Bits = 0x7FFFFFFF
};


//********************************************************************
}//namespace gui


//********************************************************************
}//namespace vertexware


