

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\Label.h"
#include "BaseTools\Time.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_cs0 {


//====================================================================
class VW_GUI_CS0_API Clock : public Label
{
public:
	//-----------------
	// Clock interface.
	//-----------------
	Clock(gui::Component* parent = 0,
			gui::MessageHandler* commandTarget = 0,
			uint commandID = 0);

	void                             SetDateTimeSeparators(const time::DateTimeSeparators& dts = time::DateTimeSeparators());
	const time::DateTimeSeparators&  GetDateTimeSeparators() const { return dateTimeSeparators; }

	// Shows time or date (can be changed at any time by user-interaction)
	void  SetShowTime(bool bShowTime);
	bool  GetShowTime() const { return bShowTime; }

	void  UpdateTextFromSystemClock();


protected:
	//---------------------
	// Component overrides.
	//---------------------
	virtual  bool  OnMouseButton(bool bDown, eMouseButton buttonCode, bool bDoubleClick, uint repeatCount, const vec2& mousePos);
	virtual  void  OnTimeDelta(double secs);
	virtual  void  OnChangedBranchVisible(bool bBranchVisible);
	virtual  void  OnChangedVisible();


protected:
	//------------
	// Properties.
	//------------
	time::DateTimeSeparators  dateTimeSeparators;

	//-------
	// Cache.
	//-------
	bool    bShowTime;
	double  accumTime;
};


//********************************************************************
}//namespace gui_cs0


//********************************************************************
}//namespace vertexware


