

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\EditBox.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_EditBoxShader : public gui_cs0::EditBox::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorDisabledBgr;
		color4b  colorDisabledBorder;
		color4b  colorDisabledText;
		color4b  colorEnabledBgr;
		color4b  colorEnabledBorder;
		color4b  colorEnabledText;
		color4b  colorFocusedBgr;
		color4b  colorFocusedBorder;
		color4b  colorFocusedText;
		color4b  colorCaret;
		float    borderWidth;
		float    caretWidth;

		ShaderParams();

		void  ChooseParams(const gui_cs0::EditBox& editBox,
						color4b& cBgr, color4b& cBorder, color4b& cText) const;
	};

	//------------------------------------------------------------
	static gui::TextAttributes __fastcall DefaultTextAttributes();


public:
	//-----------------------------
	// CS0_EditBoxShader interface.
	//-----------------------------
	CS0_EditBoxShader(const std::string& shaderName = "",
					const ShaderParams& sp = ShaderParams(),
					const gui::TextAttributes& ta = DefaultTextAttributes());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


