

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\LogoSpinners.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_LogoSpinnerShader : public gui_cs0::LogoSpinner::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorFrontTop;
		color4b  colorFrontBottom;
		color4b  colorBackTop;
		color4b  colorBackBottom;
		color4b  colorFrontTopHot;
		color4b  colorFrontBottomHot;
		color4b  colorBackTopHot;
		color4b  colorBackBottomHot;

		ShaderParams();

		void  ChooseParams(const gui_cs0::LogoSpinner& logoSpinner,
							color4b& cFrontTop, color4b& cFrontBottom,
							color4b& cBackTop, color4b& cBackBottom) const;
	};


public:
	//---------------------------------
	// CS0_LogoSpinnerShader interface.
	//---------------------------------
	CS0_LogoSpinnerShader(const std::string& shaderName = "",
						const ShaderParams& sp = ShaderParams());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


