

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\PixelOffsetControlPane.h"
#include "GUI_SS0\Buttons.h"
#include "GUI_SS0\Label.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_PixelOffsetControlPaneShader : public gui_cs0::PixelOffsetControlPane::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorScreenBorder;
		color4b  colorControlArea;

		ShaderParams();
	};


public:
	//--------------------------------------------
	// CS0_PixelOffsetControlPaneShader interface.
	//--------------------------------------------
	CS0_PixelOffsetControlPaneShader(const std::string& shaderName = "",
									const ShaderParams& sp = ShaderParams());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams());
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;

	//-------
	// Cache.
	//-------
	mutable gui::RectangleC  rControlArea;
	mutable gui::RectangleC  rBorderLeft;
	mutable gui::RectangleC  rBorderRight;
	mutable gui::RectangleC  rBorderTop;
	mutable gui::RectangleC  rBorderBottom;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


