

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\RadioButton.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_RadioButtonShader : public gui_cs0::RadioButton::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorDisabled;
		color4b  colorDisabledBgr;
		color4b  colorEnabledBorder;
		color4b  colorEnabledCenterLeft;
		color4b  colorEnabledCenterRight;
		color4b  colorEnabledBgrLeft;
		color4b  colorEnabledBgrRight;
		color4b  colorHotBgrLeft;
		color4b  colorHotBgrRight;
		color4b  colorPressedBgrLeft;
		color4b  colorPressedBgrRight;
		float    shrink;
		float    widthBorder;
		float    widthOutterRing;
		gui::TileParams  tileParams;

		ShaderParams();
	};


public:
	//---------------------------------
	// CS0_RadioButtonShader interface.
	//---------------------------------
	CS0_RadioButtonShader(const std::string& shaderName = "",
						const ShaderParams& sp = ShaderParams());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams());
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//-----------------------------
	// VideoResourceUser overrides.
	//-----------------------------
	virtual  bool  CacheTileTextureHandles(gui::Manager& gm);
	virtual  void  PostCacheTileTextureHandles();


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;

	//-------
	// Cache.
	//-------
	const gui::TileTexture*   pTileTexture;
	mutable gui::RectangleCT  rTile;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


