

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\Separators.h"
#include "GUI_SS0\Label.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_HorzSeparatorShader : public gui_cs0::HorzSeparator::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorLine;
		float    lineWidth;
		float    lineOffsetFromCenter;

		ShaderParams();
	};


public:
	//-----------------------------------
	// CS0_HorzSeparatorShader interface.
	//-----------------------------------
	CS0_HorzSeparatorShader(const std::string& shaderName = "",
							const ShaderParams& sp = ShaderParams());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//====================================================================
class VW_GUI_SS0_API CS0_HorzTextSeparatorShader : public gui_cs0::HorzTextSeparator::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorLine;
		color4b  colorText;
		float    lineWidth;
		float    lineOffsetFromCenter;

		ShaderParams();
	};


public:
	//---------------------------------------
	// CS0_HorzTextSeparatorShader interface.
	//---------------------------------------
	CS0_HorzTextSeparatorShader(const std::string& shaderName = "",
								const ShaderParams& sp = ShaderParams(),
								const gui::TextAttributes& ta = DefaultTextAttributes());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//====================================================================
class VW_GUI_SS0_API CS0_ControlGroupFrameShader : public gui_cs0::ControlGroupFrame::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorLine;
		color4b  colorText;
		float    lineWidth;
		float    lineOffsetFromCenter;

		ShaderParams();
	};


public:
	//---------------------------------------
	// CS0_ControlGroupFrameShader interface.
	//---------------------------------------
	CS0_ControlGroupFrameShader(const std::string& shaderName = "",
								const ShaderParams& sp = ShaderParams(),
								const gui::TextAttributes& ta = DefaultTextAttributes());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


