

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\Types.h"
#include "BaseTools\Constructs.h"
#include "private\vw_common_exports.h"


//********************************************************************
namespace vertexware {


//====================================================================
// Noise filtering.
// Zero-out all elements close to 0.
//====================================================================
template<typename T>
void __fastcall NoiseFilter(T* elements, uint count, T tolerance)
{
	T  negTolerance = - tolerance;

	for(uint i = 0; i < count; i++) {
		if(InRange(elements[i], negTolerance, tolerance)) elements[i] = 0;
	}
}


//====================================================================
template<typename T>
void __fastcall NoiseFilter(T* dst, const T* src, uint count, T tolerance)
{
	T  negTolerance = - tolerance;

	for(uint i = 0; i < count; i++) {
		T elem = src[i];
		if(InRange(elem, negTolerance, tolerance)) dst[i] = 0;
		else dst[i] = elem;
	}
}


//********************************************************************
}//namespace vertexware


