

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "MathTools\MathBase.h"
#include "BaseTools\Exception.h"
#include "private\vw_common_exports.h"


//********************************************************************
namespace vertexware {


//====================================================================
VW_DECLARE_EXCEPTION( MatrixNotInvertibleException );


//********************************************************************
namespace math_constants {


//====================================================================
VW_COMMON_API  VW_DECLARE_CONSTANT( float, MatrixInverseDefaultDeterminantTolerance );
VW_COMMON_API  VW_DECLARE_CONSTANT( float, MatrixInverseDefaultDividerTolerance );
VW_COMMON_API  VW_DECLARE_CONSTANT( float, MatrixNoiseFilterDefaultTolerance );


//********************************************************************
}//namespace math_constants


//====================================================================
// Dummy classes used with template calls.
//====================================================================
class VW_COMMON_API transpose_t {};
class VW_COMMON_API no_transpose_t {};


//********************************************************************
}//namespace vertexware


