

//--------------------------------------------------------------------
#include "app_null.h"


//====================================================================
VW_DECLARE_PLUGIN_ACCESS_POINT_APPLICATION(
				app_null,
				"Application.Null",
				1, 0, 0, 0,
				"Demonstrates how to setup a null-application",
				"coded by unknown")


//====================================================================
app_null::app_null()
{
	bUseOpenGL = true;
	bUseFullscreen = false;
	bUseResizable = false;
	pGR = 0;
	pVR = 0;
	pVROpenGL = 0;
	pVRDirect3D8 = 0;
}


//====================================================================
app_null::~app_null()
{
}


//====================================================================
UID  app_null::GetApplicationUID()
{
	return UID(0x46212431, 0xf7c2348a, 0x12bba901, 0x589021ef);
}


//====================================================================
void  app_null::BeginStartup(const StartupInfo& si, StartupResult& sr)
{
	sr.appProfileDir = si.processDir;
	sr.bAutoCreateProfileDir = false;
}


//====================================================================
void  app_null::QueryAutoInit(AutoInitInfo& aii)
{
}


//====================================================================
void  app_null::Initialize()
{
}


//====================================================================
void  app_null::EndStartup()
{
	pFont = gui::Manager::Instance().GetFont(gui::std_fonts::FontName_Default);
}


//====================================================================
void  app_null::Cleanup(bool bCleanExit, const FailureDesc& fd)
{
}


//====================================================================
bool  app_null::ConfirmGenericExtension(const std::string& pluginName,
							const std::string& genericExtensionInterfaceName)
{
	return false;
}


//====================================================================
void  app_null::ConnectGenericExtensions()
{
}


//====================================================================
bool  app_null::ConfirmDirectInputVersion(uint directInputVersion)
{
	return true;
}


//====================================================================
bool  app_null::ConfirmHIDDriver(const std::string& pluginName,
									uint defaultDriverPriority,
									uint& outDriverPriority)
{
	if(pluginName == VW_PLUGIN_NAME_Std_HIDDriver_0_InterSense_Tracker) return false;
	if(pluginName == VW_PLUGIN_NAME_Std_HIDDriver_0_5DT_DataGlove) return false;
	return true;
}


//====================================================================
void  app_null::QueryHIDConfig(DirectInputConfig& diConfig,
								uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
bool  app_null::QueryIgnoreHIDDriver(const std::string& pluginName)
{
	return false;
}


//====================================================================
void  app_null::BeginConfirmHumanInterfaceDevices()
{
}


//====================================================================
bool  app_null::ConfirmHumanInterfaceDevice(HumanInterfaceDevice& hid)
{
	return true;
}


//====================================================================
void  app_null::EndConfirmHumanInterfaceDevices()
{
}


//====================================================================
void  app_null::BeginConnectHumanInterfaceDevices(const DirectInputConfig& diConfig)
{
}


//====================================================================
void  app_null::ConnectHumanInterfaceDevice(HumanInterfaceDevice& hid)
{
}


//====================================================================
void  app_null::EndConnectHumanInterfaceDevices()
{
}


//====================================================================
void  app_null::SetupAsyncHIDSampling()
{
}


//====================================================================
void  app_null::DisconnectHumanInterfaceDevices()
{
}


//====================================================================
void  app_null::FilterVideoProfile(const VideoProfile& fullProfile,
									VideoProfile& outFilteredProfile)
{
}


//====================================================================
bool  app_null::ConfirmVideoRenderer(const std::string& pluginName,
										const std::string& interfaceName)
{
	return true;
}


//====================================================================
void  app_null::QueryVideoConfig(std::string& vrPluginName, VideoConfig& vc,
									uint iReconfigCount, uint reconfigCode)
{
	Kernel& k = Kernel::Instance();

	VideoConfig  vcRef;
	vcRef.frameBufferConfig.fullscreen = bUseFullscreen;
	vcRef.resizable = bUseResizable;

	if(bUseOpenGL) {
		k.ConstructClosestSafeVideoConfig(
				VW_INTERFACE_NAME_VideoRendererOpenGL, vcRef, vrPluginName, vc);
	}
	else {
		k.ConstructClosestSafeVideoConfig(
				VW_INTERFACE_NAME_VideoRendererDirect3D8, vcRef, vrPluginName, vc);
	}
}


//====================================================================
void  app_null::PostCreateMainWindow(MainWindowProperties& mwp, MainWindowGeometry& mwg,
									const std::string& vrPluginName, const VideoConfig& vc,
									uint iCreateCount)
{
}


//====================================================================
void  app_null::PreDestroyMainWindow(const MainWindowGeometry& mwg,
						const std::string& vrPluginName, const VideoConfig& vc)
{
}


//====================================================================
void  app_null::OnVSyncUpdate(bool bVSyncEnabled)
{
}


//====================================================================
void  app_null::ConnectVideoRenderer(VideoRenderer& vr)
{
	pVR = &vr;
	pGR = &pVR->GetGUIRenderer();

	pVROpenGL = InterfaceCast<VideoRendererOpenGL>(pVR);
	pVRDirect3D8 = InterfaceCast<VideoRendererDirect3D8>(pVR);
}


//====================================================================
void  app_null::DisconnectVideoRenderer()
{
	pGR = 0;
	pVR = 0;
	pVROpenGL = 0;
	pVRDirect3D8 = 0;
}


//====================================================================
void  app_null::InitVideoRendererStates(bool bPostReset)
{
}


//====================================================================
void  app_null::CreateVideoResources(bool bPostReset)
{
}


//====================================================================
void  app_null::ReleaseVideoResources(bool bPreReset)
{
}


//====================================================================
void  app_null::GenericReconfig(uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
void  app_null::InitializeSubsystems(uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
void  app_null::CleanupSubsystems(uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
void  app_null::ConnectSubsystemsToAppWindow(HWND hwnd, bool bFullscreen)
{
}


//====================================================================
void  app_null::DisconnectSubsystemsFromAppWindow()
{
}


//====================================================================
bool  app_null::CheckSubsystems()
{
	return true;
}


//====================================================================
void  app_null::FixSubsystems()
{
}


//====================================================================
void  app_null::OnKernelLevelChanged(eKernelLevel activeLevel)
{
}


//====================================================================
void  app_null::OnWindowActive(bool bActive)
{
}


//====================================================================
void  app_null::OnWindowResize(uint width, uint height)
{
}


//====================================================================
void  app_null::FrameBegin(double secsFrameTimeDelta)
{
}


//====================================================================
void  app_null::FrameSampleInput()
{
}


//====================================================================
void  app_null::FrameUpdateStates(double secsFrameTimeDelta)
{
}


//====================================================================
void  app_null::FramePreRenderVideo()
{
}


//====================================================================
void  app_null::FrameRenderVideo()
{
	gui::Renderer::ClearParams cp;
	cp.color = (pVROpenGL) ? color4b(0, 0, 128) : color4b(0, 128, 0);
	
	color4b colorAPIText = (pVROpenGL) ? color4b::RED : color4b::YELLOW;

	pGR->ClearBuffers(cp);
	pGR->Begin();

	gui::DrawTextParams dtp;

	dtp.positionTopLeft = vec2::ZERO;
	dtp.color = colorAPIText;

	pGR->DrawText(*pFont, "vertexware null-application", dtp);

	dtp.positionTopLeft = vec2(100, 100);
	dtp.color = color4b::WHITE;

	pGR->DrawText(*pFont, "Esc - exit", dtp);
	dtp.positionTopLeft.y += 32;

	pGR->DrawText(*pFont, "A - change API", dtp);
	dtp.positionTopLeft.y += 32;

	pGR->DrawText(*pFont, "F - change fullscreen", dtp);
	dtp.positionTopLeft.y += 32;

	if(! bUseFullscreen) {
		pGR->DrawText(*pFont, "R - change resizable", dtp);
	}

	dtp.positionTopLeft = vec2(0, pVR->GetWindowHeight() - dtp.tm.textHeight);
	dtp.color = colorAPIText;
	std::string sAPI = (pVROpenGL) ? "OpenGL" : "Direct3D8";

	pGR->DrawText(*pFont, sAPI, dtp);
}


//====================================================================
void  app_null::FrameRenderArea(const gui::InterleavedRenderArea& area)
{
}


//====================================================================
void  app_null::FramePostRenderVideo()
{
}


//====================================================================
void  app_null::FrameEnd()
{
}


//====================================================================
bool  app_null::GUIOnCommand(uint commandID)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnActivate(bool bActivate, bool bByMouse)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnMouseCapture(bool bCaptureBegin)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnMouseEnterExit(bool bEnter, const vec2& mousePos)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnMouseQueryCursor(const gui::Cursor* &pCursor, const vec2& mousePos)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnMouseMove(bool bHover, double hoverTimeSecs, const vec2& mousePos)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnMouseWheel(int delta, const vec2& mousePos)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnMouseButton(bool bDown, eMouseButton buttonCode, bool bDoubleClick, uint repeatCount, const vec2& mousePos)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnKeyboardQueryFocus(bool bFocusByMouse, eMouseButton buttonCode, bool& bWantFocus, bool& bNeedCharacterData)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnKeyboardFocus(bool bGotFocus)
{
	return false;
}


//====================================================================
bool  app_null::GUIOnKeyboardKey(bool bDown, eKey keyCode, uint repeatCount, char ch)
{
	if(!bDown || repeatCount) return false;

	Kernel& k = Kernel::Instance();

	switch(keyCode) {

		case Key_Escape:
			k.RequestShutdown();
			return true;

		case Key_R:
			if(! bUseFullscreen) {
				Flip(bUseResizable);
				k.RequestVideoReconfig();
			}
			return true;

		case Key_A:
			Flip(bUseOpenGL);
			k.RequestVideoReconfig();
			return true;

		case Key_F:
			Flip(bUseFullscreen);
			k.RequestVideoReconfig();
			return true;
	}
	return false;
}

