

//--------------------------------------------------------------------
#include "private\app_test1.h"


//====================================================================
// Demo parameters.
//====================================================================
const char* gc_szBgrImageFileNames[gc_NumImages] =
{
	"elise_111s_01.jpg",
	"elise_111s_02.tif",
	"elise_111s_03.bmp",
	"elise_111s_04.png",
	"maranello_spider8.jpg"
};

const char*    gc_szScreenShotFileName = "app_test1_screenshot";

const color4f  gc_RubberbandTrailColor = color4f(0.75, 0.75, 0, 0.75);
const float    gc_RubberbandTrailFadeSpeed = 2.0;

const color4b  gc_HelpTextColor = color4b(255, 0, 0, 192);
const color4b  gc_HelpTextColorBgr = color4b(0, 0, 0, 128);
const float    gc_HelpTextBgrHalfExtend = 10;
const float    gc_HelpTextOffset = 80;
const float    gc_HelpTextHeight = 22;
const float    gc_HelpTextMinSpeed = -300;
const float    gc_HelpTextMaxSpeed = +300;

const vec3     gc_InfoLabelPosMin = vec2(40, 40);
const vec3     gc_InfoLabelPosMax = vec2(80, 80);

const vec2     gc_HPRLabelPos= vec2(20, 200);

const color4b  gc_EventLogBgrColor = color4b(0, 0, 0, 128);
const color4b  gc_EventLogTextColor = color4b(192, 192, 0, 255);
const float    gc_EventLogBgrOffsetR = 320;
const float    gc_EventLogBgrWidth = 300;
const float    gc_EventLogTextOffsetR = 300;
const float    gc_EventLogTextHeight = 18;

const uint     gc_TextureWidth  = 512;
const uint     gc_TextureHeight = 512;
const bool     gc_TextureUseMipmaps = true;

const float    gc_FOVY = 60.0;
const float    gc_NearPlane = 10;
const float    gc_FarPlane  = 200;

const uint     gc_SphereSection0SubdivH = 16;
const uint     gc_SphereSection0SubdivV = 12;
const float    gc_SphereSection0AngleH = 120;
const float    gc_SphereSection0AngleV = 90;
const float    gc_SphereSection0Radius = 100;

const uint     gc_SphereSection1SubdivH = 12;
const uint     gc_SphereSection1SubdivV = 16;
const float    gc_SphereSection1AngleH = 100;
const float    gc_SphereSection1AngleV = 120;
const float    gc_SphereSection1Radius = 120;

const uint     gc_SphereSection2SubdivH = 16;
const uint     gc_SphereSection2SubdivV = 12;
const float    gc_SphereSection2AngleH = 120;
const float    gc_SphereSection2AngleV = 90;
const float    gc_SphereSection2Radius = 100;

const vec3     gc_Bgr1RotMin   = vec3(-30, -10, -5);
const vec3     gc_Bgr1RotMax   = vec3(+30, +10, +5);
const vec3     gc_Bgr1RotSpeed = vec3(3, 2, 1);

const vec3     gc_Bgr0RotMin                  = vec3(-15, -240, -10);
const vec3     gc_Bgr0RotMax                  = vec3(+15, +240, +10);
const vec3     gc_Bgr0RotSpeed                = vec3(4, 5, 2);
const vec3     gc_Bgr0RotFactorViewController = vec3(45, 90, 30);
const float    gc_Bgr0MaxPitchViewController  = 50;

const float    gc_Bgr0AlphaMin   = -0.5;
const float    gc_Bgr0AlphaMax   = +2.5;
const float    gc_Bgr0AlphaSpeed =  0.05;

const float    gc_LightIntensityMin   = 0.4;
const float    gc_LightIntensityMax   = 1.4;
const float    gc_LightIntensitySpeed = 0.1;

const bool     gc_HIDD_DefaultEnable_GenericGameController = true;
const bool     gc_HIDD_DefaultEnable_InterSenseTracker = false;
const bool     gc_HIDD_DefaultEnable_5DTDataGlove = false;


//====================================================================
// Animation helper routines.
//====================================================================
void  PingPongValue(float timeDelta, float& valueSpeed, float& value,
					float minValue, float maxValue)
{
	value += valueSpeed * timeDelta;
	if(value <= minValue) {
		value = minValue;
		FlipSign(valueSpeed);
	}
	else if(value >= maxValue) {
		value = maxValue;
		FlipSign(valueSpeed);
	}
}


//====================================================================
void  PingPongValue(float timeDelta, vec3& valueSpeed, vec3& value,
					const vec3& minValue, const vec3& maxValue)
{
	PingPongValue(timeDelta, valueSpeed.x, value.x, minValue.x, maxValue.x);
	PingPongValue(timeDelta, valueSpeed.y, value.y, minValue.y, maxValue.y);
	PingPongValue(timeDelta, valueSpeed.z, value.z, minValue.z, maxValue.z);
}


//====================================================================
void  DrawShadowText(const std::string& s, gui::DrawTextParams& dtp,
					gui::Renderer& gr, const gui::Font& font,
					const vec2& pos, const vec2& shadowOffset = vec2(2, 2),
					color4b cText = color4b(255, 255, 255, 192),
					color4b cShadow = color4b(0, 0, 0, 160))
{
	dtp.positionTopLeft = pos + shadowOffset;
	dtp.color = cShadow;
	gr.DrawText(font, s, dtp);

	dtp.positionTopLeft = pos;
	dtp.color = cText;
	gr.DrawText(font, s, dtp);
}


//====================================================================
// Initialize unsafe values only.
// Real initialization is to be done when & where kernel says so.
//====================================================================
app_test1::app_test1()
{
	pDynamicTestPane = 0;

	interleavedViewConfig.maxHorz  = gc_SphereSection2AngleH;
	interleavedViewConfig.maxVert  = gc_SphereSection2AngleV;
	interleavedViewConfig.pageHorz = gc_SphereSection2AngleH * 0.8f;
	interleavedViewConfig.pageVert = gc_FOVY;
	interleavedViewConfig.posHorz  = (interleavedViewConfig.maxHorz - interleavedViewConfig.pageHorz) * 0.5f;
	interleavedViewConfig.posVert  = (interleavedViewConfig.maxVert - interleavedViewConfig.pageVert) * 0.5f;

	miscConfig.screenshotFormat = signal_codec_parameters::Value_ImageFileFormat_JPEG;
	iScreenShotSerial = 0;

	bEventLogShow = true;
	bEventLogQueryCursor = false;
	bEventLogMouseMove = false;

	bDrawRubberbandTrail = false;

	lightIntensity = 1;
	lightIntensitySpeed = 0.1;
	bgr0Alpha = 1;
	bgr0AlphaSpeed = 0.05;
	bgr0RotSpeed = gc_Bgr0RotSpeed;
	bgr1RotSpeed = gc_Bgr1RotSpeed;
	bgr0Rot = vec3::ZERO;
	bgr1Rot = vec3::ZERO;

	pVRend = 0;
	pVRendGL = 0;
	pVRendD3D8 = 0;
	pGRend = 0;

	pMouse = 0;
	pKeyboard = 0;
	pGameController = 0;
	pPositionTracker = 0;
	pOrientationTracker = 0;
	pGlove = 0;
}


//====================================================================
// Do NOT fiddle with subsystems or system-resources around here.
// Releasing pure memory blocks is safe. However, it is
// recommened that cleanup is done in Cleanup(), pardon the expression.
//====================================================================
app_test1::~app_test1()
{
	// For purposes of specification testing, the demo actually
	// releases some memory here through auto-pointers.
}


//====================================================================
// Dialog communication helpers.
//====================================================================
void  app_test1::GetViewConfig(ViewConfig& _vc, bool& _bHasGameController, bool& _bHasOrientationTracker) const
{
	_vc = viewConfig;
	_bHasGameController = (pGameController != 0);
	_bHasOrientationTracker = (pOrientationTracker != 0);
}


//====================================================================
void  app_test1::SetViewConfig(const ViewConfig& _vc)
{
	viewConfig = _vc;

	// Check & fix settings
	switch(viewConfig.activeController) {

		case ViewController_Keyboard:
			if(! pKeyboard) viewConfig.activeController = ViewController_None;
			break;
		case ViewController_Mouse:
			if(! pMouse) viewConfig.activeController = ViewController_None;
			break;
		case ViewController_GameController:
			if(! pGameController) viewConfig.activeController = ViewController_None;
			break;
	}
	if(! pOrientationTracker) {
		viewConfig.bCombineTrackerReadings = false;
	}

	// Update drawing variables
	if(viewConfig.activeController == ViewController_None) {

		ComponentClamp(bgr0Rot, gc_Bgr0RotMin, gc_Bgr0RotMax);
		bgr0RotSpeed = gc_Bgr0RotSpeed;
	}
	else {
		bgr0Rot.Set(0, 0, 0);
		bgr0RotSpeed.Set(0, 0, 0);
	}

	// Update mouse-interface properties
	if(pMouse) {
		bool bMouseRelativeMode = (viewConfig.activeController == ViewController_Mouse);
		pMouse->ActivateRelativeMode(bMouseRelativeMode);
	}

	// Update tracker-interface properties
	if(pOrientationTracker) {
		pOrientationTracker->SetReverseHead(viewConfig.bReverseTrackerHead);
		pOrientationTracker->SetReversePitch(viewConfig.bReverseTrackerPitch);
		pOrientationTracker->SetReverseRoll(viewConfig.bReverseTrackerRoll);
	}

	// Update dialog controls
	pOptionsDialog->UpdateControlDependencies();

	// Update info-labels
	sActiveController = "View: ";

	switch(viewConfig.activeController) {

		case ViewController_None:
			sActiveController += "animated";
			break;

		case ViewController_Keyboard:
			sActiveController += "keyboard";
			break;

		case ViewController_Mouse:
			sActiveController += "mouse";
			break;

		case ViewController_GameController:
			sActiveController += "game-controller";
			break;
	}

	sHeadTracker = "Tracker: ";
	if(pOrientationTracker) {
		if(viewConfig.bCombineTrackerReadings) sHeadTracker += "combined";
		else sHeadTracker += "ignored";
	}
	else {
		sHeadTracker += "not attached";
	}
}


//====================================================================
void  app_test1::GetAsyncConfig(AsyncSampleConfig asConfig[AsyncController_Count]) const
{
	for(uint i = 0; i < AsyncController_Count; i++) {
		asConfig[i] = asyncSampleConfigs[i];
	}
}


//====================================================================
void  app_test1::SetAsyncConfig(const AsyncSampleConfig asConfig[AsyncController_Count])
{
	for(uint i = 0; i < AsyncController_Count; i++) {
		HIDController* c = asyncSampleConfigs[i].controller;
		asyncSampleConfigs[i] = asConfig[i];
		asyncSampleConfigs[i].controller = c;
	}
	SetupAsyncHIDSampling();
}


//====================================================================
void  app_test1::GetInterleavedViewConfig(InterleavedViewConfig& ivc) const
{
	ivc = interleavedViewConfig;
}


//====================================================================
void  app_test1::SetInterleavedViewConfig(const InterleavedViewConfig& ivc)
{
	interleavedViewConfig.posHorz = ivc.posHorz;
	interleavedViewConfig.posVert = ivc.posVert;
}


//====================================================================
void  app_test1::GetMiscConfig(MiscConfig& mc) const
{
	mc = miscConfig;
}


//====================================================================
void  app_test1::SetMiscConfig(const MiscConfig& mc)
{
	miscConfig = mc;
}


//====================================================================
// Application-class override methods.
//====================================================================
UID  app_test1::GetApplicationUID()
{
	// Change this for each application. Range
	// UID(0x00000000, 0x00000000, 0x00000000, 0x00000000) to
	// UID(0x00000000, 0x00000000, 0x00000000, 0xFFFFFFFF)
	// is reserved for library distribution

	return UID(0x00000000, 0x00000000, 0x00000000, 0x00000001);
}


//====================================================================
void  app_test1::BeginStartup(const StartupInfo& si, StartupResult& sr)
{
	// adjust log window name
	sr.appWindowText = "Loading " + sr.appWindowText;

	// store some info for later use
	sProfileDirectoryName = si.appProfileDir;
}


//====================================================================
void  app_test1::QueryAutoInit(AutoInitInfo& aii)
{
}


//====================================================================
// Real initialization takes place in this lengthy piece of code.
//====================================================================
void  app_test1::Initialize()
{
	//----------------------------------------------
	// Timer will measure initialization performance
	//----------------------------------------------
	HighResolutionTimer hrt;
	hrt.Start();

	//--------------------------------------------------------------------------------
	// Create master image storage (this demo will not bother to release it
	// until exit, image data will be copied & redundantly stored in multiple objects)
	//--------------------------------------------------------------------------------
	{for(uint i = 0; i < gc_NumImages; i++) {
		apImage[i].Assign(ManufactureImage(SampleFormat_X8R8G8B8, gc_TextureHeight, gc_TextureWidth));
	}}

	//-----------------------
	// Load background images
	//-----------------------
	{for(uint i = 0; i < gc_NumImages; i++) {

		olog << "Loading background image: " << gc_szBgrImageFileNames[i] << std::endl;

		// Create temporary object (just set desired sample format, which
		// tells the loading routine what sample-type is required as output)
		AutoPtr<ImageBase> apTempImage(ManufactureImage(SampleFormat_X8R8G8B8));

		// try loading through registered codecs
		if(! LoadImageAs(*apTempImage, gc_szBgrImageFileNames[i])) {
			VW_THROW(ApplicationException, "Cannot load background image: " + std::string(gc_szBgrImageFileNames[i]));
		}

		// simply copy/resize loaded images into prepared storage,
		// we dont care about image aspect-ratio
		Resample2D(*apImage[i], *apTempImage, ResampleFilter_Linear);
	}}

	//-----------------------------------------------
	// Generate vertex data for background rendering.
	//-----------------------------------------------
	olog << "Generating vertex data." << std::endl;

	// near background
	GenerateSphereSectionVertices(
						apVerticesSphereSection0,
						gc_SphereSection0SubdivH, gc_SphereSection0SubdivV,
						gc_SphereSection0AngleH, gc_SphereSection0AngleV,
						gc_SphereSection0Radius);

	GenerateSphereSectionVerticesD3D8(
						apVerticesSphereSection0,
						apUPVertexBufferD3D8[0], apVertexAlphaD3D8[0],
						vertexCountD3D8[0],
						gc_SphereSection0SubdivH, gc_SphereSection0SubdivV);

	// far background
	GenerateSphereSectionVertices(
						apVerticesSphereSection1,
						gc_SphereSection1SubdivH, gc_SphereSection1SubdivV,
						gc_SphereSection1AngleV, gc_SphereSection1AngleV,
						gc_SphereSection1Radius);

	GenerateSphereSectionVerticesD3D8(
						apVerticesSphereSection1,
						apUPVertexBufferD3D8[1], apVertexAlphaD3D8[1],
						vertexCountD3D8[1],
						gc_SphereSection1SubdivH, gc_SphereSection1SubdivV);

	// interleaved render background
	GenerateSphereSectionVertices(
						apVerticesSphereSection2,
						gc_SphereSection2SubdivH, gc_SphereSection2SubdivV,
						gc_SphereSection2AngleV, gc_SphereSection2AngleV,
						gc_SphereSection2Radius);

	GenerateSphereSectionVerticesD3D8(
						apVerticesSphereSection2,
						apUPVertexBufferD3D8[2], apVertexAlphaD3D8[2],
						vertexCountD3D8[2],
						gc_SphereSection2SubdivH, gc_SphereSection2SubdivV);

	//--------------------------------------------------------
	// Register gui-shaders from standard shader-set-0.
	// You can change shader settings (colors etc) by
	// modifying the data members of ShaderFactory directly,
	// or circumvent the ShaderFactory altogether and register
	// each shader individually.
	// You can also create your own shaders for any
	// component and use it instead of default shaders from
	// set0. Furthermore, you can create custom components
	// which still use gui-manager/gui-renderer services.
	//--------------------------------------------------------
	olog << "Registering shader-set-0." << std::endl;

	gui_ss0::ShaderFactory  shaderFactory;
	shaderFactory.CreateShaders();

	//----------------------------------------------------
	// Create gui-components from standard component-set-0
	//----------------------------------------------------
	olog << "Creating gui." << std::endl;

	gui::Manager& gm = gui::Manager::Instance();

	// Most components will use application-object as command-target
	gui::MessageHandler* cmdTarget = this;

	// Create tooltip-object and register it as service-provider for tooltip-service.
	// Also, bump the layer on this one (it should be on top of all other components)
	pToolTip = new ToolTip;
	pToolTip->RegisterAsServiceProvider(SID_ToolTip);
	pToolTip->SetLayer(10);

	// Create main-menu
	pMenuBar = new MenuBar();
	pMenuBar->SetMenuBarSubcomponentLayout(true);

	pMenuTitleSystem = new MenuTitle(pMenuBar, "System");
	pMenuPaneSystem = new MenuPane(*pMenuTitleSystem);
	pMenuItemFrameStats = new MenuItem(pMenuPaneSystem, cmdTarget, CID_OpenFrameStatsPane, "Frame statistics...");
	pMenuItemConsole = new MenuItem(pMenuPaneSystem, cmdTarget, CID_OpenConsole, "Console...");
	pMenuItemProfiler = new MenuItem(pMenuPaneSystem, cmdTarget, CID_OpenProfilerDialog, "Profiler...");
	pMenuSeparatorSystem1 = new MenuSeparator(pMenuPaneSystem);
	pMenuItemExit = new MenuItem(pMenuPaneSystem, cmdTarget, CID_ExitProgram, "Exit");

	pMenuTitleConfig = new MenuTitle(pMenuBar, "Config");
	pMenuPaneConfig = new MenuPane(*pMenuTitleConfig);
	pMenuItemVSync = new MenuItem(pMenuPaneConfig, cmdTarget, CID_VSync, "VSync on/off", MenuItem::Style_OnOff);
	pMenuItemVideoConfig = new MenuItem(pMenuPaneConfig, cmdTarget, CID_OpenVideoConfigDialog, "Video config...");
	pMenuItemPixelOffset = new MenuItem(pMenuPaneConfig, cmdTarget, CID_OpenPixelOffsetPane, "Pixel offset...");
	pMenuSeparatorConfig1 = new MenuSeparator(pMenuPaneConfig);
	pMenuItemInputConfig = new MenuItem(pMenuPaneConfig, cmdTarget, CID_OpenHIDConfigDialog, "Input config...");
	pMenuItemHIDReconfigCycle = new MenuItem(pMenuPaneConfig, cmdTarget, CID_HIDReconfigCycle, "HID reconfig cycle");
	pMenuItemHIDDrivers = new MenuItem(pMenuPaneConfig, 0, 0, "Used HID drivers");
	pMenuPaneHIDDrivers = new MenuPane(*pMenuItemHIDDrivers);

	pMenuItemHIDDriverGenericGameController = new MenuItem(pMenuPaneHIDDrivers, 0, 0, "Generic game controller", MenuItem::Style_OnOff);
	pMenuItemHIDDriverGenericGameController->SetOn(gc_HIDD_DefaultEnable_GenericGameController);
	pMenuItemHIDDriverGenericGameController->SetEnabled(false);

	pMenuItemHIDDriverInterSenseTracker = new MenuItem(pMenuPaneHIDDrivers, 0, 0, "InterSense tracker", MenuItem::Style_OnOff);
	pMenuItemHIDDriverInterSenseTracker->SetOn(gc_HIDD_DefaultEnable_InterSenseTracker);
	pMenuItemHIDDriverInterSenseTracker->SetEnabled(false);

	pMenuItemHIDDriver5DTDataGlove = new MenuItem(pMenuPaneHIDDrivers, 0, 0, "5DT DataGlove", MenuItem::Style_OnOff);
	pMenuItemHIDDriver5DTDataGlove->SetOn(gc_HIDD_DefaultEnable_5DTDataGlove);
	pMenuItemHIDDriver5DTDataGlove->SetEnabled(false);

	pMenuItemControllerStates = new MenuItem(pMenuPaneConfig, 0, 0, "Controller states");
	pMenuPaneControllerStates = new MenuPane(*pMenuItemControllerStates);
	pMenuItemControllerStateMouse = new MenuItem(pMenuPaneControllerStates, cmdTarget, CID_OpenMouseStatePane, "Mouse...");
	pMenuItemControllerStateKeyboard = new MenuItem(pMenuPaneControllerStates, cmdTarget, CID_OpenKeyboardStatePane, "Keyboard...");
	pMenuItemControllerStateGameController = new MenuItem(pMenuPaneControllerStates, cmdTarget, CID_OpenGameControllerStatePane, "Game controller...");
	pMenuItemControllerStateOrientationTracker = new MenuItem(pMenuPaneControllerStates, cmdTarget, CID_OpenOrientationTrackerStatePane, "Orientation tracker...");
	pMenuItemControllerStatePositionTracker = new MenuItem(pMenuPaneControllerStates, cmdTarget, CID_OpenPositionTrackerStatePane, "Position tracker...");
	pMenuItemControllerStateGlove = new MenuItem(pMenuPaneControllerStates, cmdTarget, CID_OpenGloveStatePane, "Glove...");

	pMenuSeparatorConfig2 = new MenuSeparator(pMenuPaneConfig);
	pMenuItemVSD3D8 = new MenuItem(pMenuPaneConfig, 0, 0, "vs_direct3d8");
	pMenuPaneVSD3D8 = new MenuPane(*pMenuItemVSD3D8);
	pMenuItemVSD3D8Cleanup = new MenuItem(pMenuPaneVSD3D8, this, CID_VSD3D8Cleanup, "cleanup order destroy/release", MenuItem::Style_OnOff);
	pMenuItemVSD3D8Cleanup->SetOn(true);

	pMenuTitleTools = new MenuTitle(pMenuBar, "Tools");
	pMenuPaneTools = new MenuPane(*pMenuTitleTools);
	pMenuItemFontTest = new MenuItem(pMenuPaneTools, cmdTarget, CID_OpenFontTest, "Font test...");
	pMenuItemClockTest = new MenuItem(pMenuPaneTools, cmdTarget, CID_OpenClockTest, "Clock...");
	pMenuItemToolBarTest1 = new MenuItem(pMenuPaneTools, cmdTarget, CID_OpenToolBarTest1, "ToolBar test 1...");
	pMenuItemToolBarTest2 = new MenuItem(pMenuPaneTools, cmdTarget, CID_OpenToolBarTest2, "ToolBar test 2...");
	pMenuSeparatorTools1= new MenuSeparator(pMenuPaneTools);
	pMenuItemDynamicTestPane = new MenuItem(pMenuPaneTools, cmdTarget, CID_CreateDynamicTestPane, "Create dynamic-test pane...");
	pMenuItemSubsysReconfig = new MenuItem(pMenuPaneTools, cmdTarget, CID_AppSubsysReconfigCycle, "AppSubsys reconfig cycle");

	pMenuTitleDemo = new MenuTitle(pMenuBar, "Demo");
	pMenuPaneDemo = new MenuPane(*pMenuTitleDemo);
	pMenuItemOptions = new MenuItem(pMenuPaneDemo, cmdTarget, CID_OpenDemoOptions, "Options...");
	pMenuItemAbout = new MenuItem(pMenuPaneDemo, cmdTarget, CID_OpenDemoAbout, "About...");

	// Create context menu
	pMenuPaneContext = new MenuPane;
	pMenuItemLightWhite = new MenuItem(pMenuPaneContext, cmdTarget, CID_LightColor, "Light white", MenuItem::Style_Selection, 0);
	pMenuItemLightWhite->Select();
	pMenuItemLightRed = new MenuItem(pMenuPaneContext, cmdTarget, CID_LightColor, "Light red", MenuItem::Style_Selection, 0);
	pMenuItemLightGreen = new MenuItem(pMenuPaneContext, cmdTarget, CID_LightColor, "Light green", MenuItem::Style_Selection, 0);
	pMenuItemLightBlue = new MenuItem(pMenuPaneContext, cmdTarget, CID_LightColor, "Light blue", MenuItem::Style_Selection, 0);
	pMenuSeparatorContext1 = new MenuSeparator(pMenuPaneContext);
	pMenuItemEnableRubberband = new MenuItem(pMenuPaneContext, cmdTarget, CID_EnableRubberband, "Enable rubberband", MenuItem::Style_OnOff);
	pMenuItemEnableRubberband->SetOn(true);
	pMenuSeparatorContext2 = new MenuSeparator(pMenuPaneContext);
	pMenuItemEventLogShow = new MenuItem(pMenuPaneContext, cmdTarget, CID_EventLogShow, "Show event log", MenuItem::Style_OnOff);
	pMenuItemEventLogQueryCursor = new MenuItem(pMenuPaneContext, cmdTarget, CID_EventLogQueryCursor, "Log QueryCursor", MenuItem::Style_OnOff);
	pMenuItemEventLogMouseMove = new MenuItem(pMenuPaneContext, cmdTarget, CID_EventLogMouseMove, "Log MouseMove", MenuItem::Style_OnOff);

	// Create rubberband
	pRubberBand = new Rubberband(this, CID_RubberBand);

	// Create console
	pConsole = new Console;
	pConsole->SetPositionTopLevelFrame(80, 80);

	// Create profiler dialog
	pProfilerControlDialog = new ProfilerControlDialog;
	pProfilerControlDialog->SetPositionTopLevelFrame(100, 100);

	// Create frame-statistics pane and connect it to worker object.
	// Align this pane to bottom-left of the window
	pFrameStatsPane = new FrameStatisticsPane;
	pFrameStatsPane->SetAutoPositionOnWindowResize(AutoPosition_AlignNear, AutoPosition_AlignFar, 0, 0);
	pFrameStatsPane->SetVisible(true);

	// Create video-config dialog
	pVideoConfigDialog = new VideoConfigDialog;
	pVideoConfigDialog->SetPositionTopLevelFrame(50, 50);

	// Create pixel-offset controls
	pPixelOffsetControlPane = new PixelOffsetControlPane;

	// Create input-config dialog
	pHIDConfigDialog = new HIDConfigDialog;
	pHIDConfigDialog->SetPositionTopLevelFrame(60, 60);

	// Create human-interface-device state panes
	pMouseStatePane = new MouseStatePane;
	pMouseStatePane->SetPosition(150, 150);

	pKeyboardStatePane = new KeyboardStatePane;
	pKeyboardStatePane->SetPosition(160, 170);

	pGameControllerStatePane = new GameControllerStatePane;
	pGameControllerStatePane->SetPosition(170, 190);

	pOrientationTrackerStatePane = new OrientationTrackerStatePane;
	pOrientationTrackerStatePane->SetPosition(190, 210);

	pPositionTrackerStatePane = new PositionTrackerStatePane;
	pPositionTrackerStatePane->SetPosition(210, 230);

	pGloveStatePane = new GloveStatePane;
	pGloveStatePane->SetPosition(230, 250);

	// Create test components
	pFontTest = new FontTest;
	pFontTest->SetPosition(30, 90);

	pClockTestPane = new ClockTestPane;
	pClockTestPane->SetAutoPositionOnWindowResize(AutoPosition_AlignFar, AutoPosition_AlignFar, 0, 0);
	pClockTestPane->SetVisible(true);

	pToolBarTest1 = new ToolBarTest1(cmdTarget, CID_ToolBarTest1Button);
	pToolBarTest1->SetPosition(10, 50);

	pToolBarTest2 = new ToolBarTest2(cmdTarget, CID_ToolBarTest2Button);
	pToolBarTest2->SetPosition(20, 60);

	// Create options dialog
	pOptionsDialog = new OptionsDialog(*this);
	pOptionsDialog->SetPositionTopLevelFrame(30, 30);

	// Create about dialog. Center the dialog on screen initially
	pAboutDialog = new AboutDialog("About " + GetPluginInfo().GetPluginName());

	pAboutDialog->SetAboutDialogSubcomponentText(
			"This demo shows how\nto construct a simple\nvertexware application.\n"
			"Coded by petar.basic.2002\nCopyright FER.Zagreb.Croatia");

	pAboutDialog->SetAutoPositionOnWindowResize(AutoPosition_Center, AutoPosition_Center, 0, 0);

	//-------------------------------------------
	// Modify top-level cycle queue if necessary.
	//-------------------------------------------
	gm.CycleQueueOrder(*this, *pConsole);

	//------------------------------------
	// Cache pointers to some gui-objects.
	//------------------------------------
	pFont = gm.GetFont(std_fonts::FontName_Default);
	if(! pFont) {
		VW_THROW(ApplicationException, "Default font was not registered.");
	}

	//---------------------------
	// Construct help text params
	//---------------------------
	sHelpText += GetKeyName(Key_F1) + " = help on-off / ";
	sHelpText += GetKeyName(Key_F2) + " = quick info on-off / ";
	sHelpText += GetKeyName(Key_F3) + " = hpr info on-off / ";
	sHelpText += GetKeyName(Key_Escape) + " = show main menu / ";
	sHelpText += GetKeyModifierName(KeyModifier_Shift) + "-" + GetKeyName(Key_Escape) + " = exit demo / ";
	sHelpText += GetKeyName(Key_PrintScreen) + " = screenshot / ";
	sHelpText += GetKeyName(Key_R) + " = reset tracker / ";
	sHelpText += GetKeyName(Key_T) + " = combine tracker into final view-transform / ";
	sHelpText += GetKeyName(Key_C) + " = cycle view-controllers / ";
	sHelpText += "Keyboard: arrows = rotate view, space = reset view / ";
	sHelpText += "Mouse: movement = rotate view, wheel = sensitivity, buttons = reset view / ";
	sHelpText += "GameController: axes = rotate view, slider = sensitivity, buttons = reset view";

	bShowHelp = true;
	fHelpSpeed = gc_HelpTextMaxSpeed * 0.25f;
	dtpHelpText.tm.textHeight = gc_HelpTextHeight;
	dtpHelpText.color = gc_HelpTextColor;
	posHelpText = vec2(400, 0);
	rHelpTextBgr.width = pFont->CalcTextWidth(dtpHelpText.tm, sHelpText) + gc_HelpTextBgrHalfExtend * 2;
	rHelpTextBgr.height = gc_HelpTextHeight;
	rHelpTextBgr.SetColor(gc_HelpTextColorBgr);

	bShowInfoLabels = true;
	fInfoLabelAlpha = 0.5;
	fInfoLabelAlphaSpeed = 0.3;
	speedInfoLabels.Set(2, 3, 0);
	dtpInfoLabels.color = color4b(255, 255, 255, 192);
	posInfoLabels = gc_InfoLabelPosMin;
	dtpInfoLabels.tm.textHeight = 20;

	bShowHPRLabel = true;
	dtpHPRLabel.positionTopLeft = gc_HPRLabelPos;
	dtpHPRLabel.tm.textHeight = 20;
	dtpHPRLabel.tm.bMonospace = true;

	//-----------------
	// Init light color
	//-----------------
	UpdateLightColorFromGUI();

	//---------------------------
	// Construct event-log params
	//---------------------------
	rEventLogBgr.SetColor(gc_EventLogBgrColor);
	dtpEventLog.tm.textHeight = gc_EventLogTextHeight;
	dtpEventLog.color = gc_EventLogTextColor;

	SyncGUIWithEventLogStates();

	//-----------------------------------
	// Create & setup some worker objects
	//-----------------------------------
	olog << "Creating worker objects." << std::endl;

	// Collects frame statistics (fps, total time...)
	apFrameStatsCollector.Assign(new FrameStatisticsCollector);

	// Interpreter...interprets command-lines
	apCommandInterpreter.Assign(new std_command_interpreter::Interpreter);

	// Create and register all available commands
	framework_commands::CreateAndRegisterAllCommands(*apCommandInterpreter, pConsole);
	framework_commands_opengl::CreateAndRegisterAllCommands(*apCommandInterpreter);

	// Make some command-line shortcuts
	apCommandInterpreter->RegisterAlias("ls", "list-commands");
	apCommandInterpreter->RegisterAlias("cls", "console-buffers -clear-output");
	apCommandInterpreter->RegisterAlias("hidi", "hid-control -info");
	apCommandInterpreter->RegisterAlias("vc", "video-config");
	apCommandInterpreter->RegisterAlias("ogl", "vr-opengl");

	//----------------------------------------------
	// Connect worker objects to gui where necessary
	//----------------------------------------------
	pFrameStatsPane->SetCollector(apFrameStatsCollector);

	pConsole->ConnectCommandInterpreter(*apCommandInterpreter);

	//-------------------------------------------------------------------
	// Export some animation variables to global variable registry.
	// Used to enable run-time update of variable-values through console.
	//-------------------------------------------------------------------
	VariableRegistry& varReg = Kernel::Instance().GetVariableRegistry();

	varReg.RegisterVariable(VariableProxyRangeCheckedFloat(
					&fHelpSpeed, gc_HelpTextMinSpeed, gc_HelpTextMaxSpeed,
					"helpSpeed", "help-text scroll speed"));

	varReg.RegisterVariable(VariableProxyBool(
					&bShowHelp, "showHelp", "show/hide scrolling help-text"));

	varReg.ForceValueRanges();

	//-------------------
	// Report performance
	//-------------------
	olog << "Initialization time: " << hrt.GetElapsedSeconds() << " seconds." << nl;
}


//====================================================================
// Called before kernel enters config-loop for the first time.
//====================================================================
void  app_test1::EndStartup()
{
	Kernel& k = Kernel::Instance();

	// Update gui to reflect available hid-drivers

	pMenuItemHIDDriverGenericGameController->SetEnabled(false);
	pMenuItemHIDDriverInterSenseTracker->SetEnabled(false);
	pMenuItemHIDDriver5DTDataGlove->SetEnabled(false);

	for(uint i = 0; i < k.GetNumHIDDrivers(); i++) {

		PluginInfo pi;
		k.GetHIDDriverInfo(i, pi);

		if(pi.GetPluginName() == VW_PLUGIN_NAME_Std_HIDDriver_8_Generic_GameController) {
			pMenuItemHIDDriverGenericGameController->SetEnabled(true);
		}
		if(pi.GetPluginName() == VW_PLUGIN_NAME_Std_HIDDriver_0_InterSense_Tracker) {
			pMenuItemHIDDriverInterSenseTracker->SetEnabled(true);
		}
		if(pi.GetPluginName() == VW_PLUGIN_NAME_Std_HIDDriver_0_5DT_DataGlove) {
			pMenuItemHIDDriver5DTDataGlove->SetEnabled(true);
		}
	}

	// Setup some plugin specific parameters
	k.SetPluginParameter(VW_PLUGIN_NAME_Std_VideoSubsystem_Direct3D8,
			NamedParameter(VW_PLUGIN_PARAM_NAME_VS_DIRECT3D8_DestroyWindowBeforeD3DObjectRelease,
							pMenuItemVSD3D8Cleanup->IsOn()));
}


//====================================================================
// Real cleanup should be put here.
//====================================================================
void  app_test1::Cleanup(bool bCleanExit, const FailureDesc& fd)
{
	// Release storage, delete objects.
	// If <bCleanExit> is false, <fd> can be used to decide what system-checks
	// need to be done at next application startup, or used to invalidate
	// some parts of configuration files.
}


//====================================================================
bool  app_test1::ConfirmGenericExtension(const std::string& pluginName,
							const std::string& genericExtensionInterfaceName)
{
	return false;
}


//====================================================================
void  app_test1::ConnectGenericExtensions()
{
}


//====================================================================
bool  app_test1::ConfirmDirectInputVersion(uint directInputVersion)
{
	return true;
}


//====================================================================
bool  app_test1::ConfirmHIDDriver(const std::string& pluginName,
										uint defaultDriverPriority,
										uint& outDriverPriority)
{
	// accept all drivers
	return true;
}


//====================================================================
void  app_test1::QueryHIDConfig(DirectInputConfig& diConfig,
								uint iReconfigCount, uint reconfigCode)
{
	olog << "app_test1 received QueryHIDConfig\n";
	olog << "reconfigCount = " << iReconfigCount << nl;
	olog << "reconfigCode = " << reconfigCode << nl;
}


//====================================================================
bool  app_test1::QueryIgnoreHIDDriver(const std::string& pluginName)
{
	// Called once per HID-reconfig cycle. Demo will disable
	// some known human-interface-device drivers here,
	// to avoid long startup/reconfig time caused by device detection.

	if(pluginName == VW_PLUGIN_NAME_Std_HIDDriver_8_Generic_GameController) {
		return ! pMenuItemHIDDriverGenericGameController->IsOn();
	}
	if(pluginName == VW_PLUGIN_NAME_Std_HIDDriver_0_InterSense_Tracker) {
		return ! pMenuItemHIDDriverInterSenseTracker->IsOn();
	}
	if(pluginName == VW_PLUGIN_NAME_Std_HIDDriver_0_5DT_DataGlove) {
		return ! pMenuItemHIDDriver5DTDataGlove->IsOn();
	}
	// ignore unknown
	return true;
}


//====================================================================
void  app_test1::BeginConfirmHumanInterfaceDevices()
{
}


//====================================================================
bool  app_test1::ConfirmHumanInterfaceDevice(HumanInterfaceDevice& hid)
{
	// Check device and return false to discard
	return true;
}


//====================================================================
void  app_test1::EndConfirmHumanInterfaceDevices()
{
}


//====================================================================
void  app_test1::BeginConnectHumanInterfaceDevices(const DirectInputConfig& diConfig)
{
}


//====================================================================
void  app_test1::ConnectHumanInterfaceDevice(HumanInterfaceDevice& hid)
{
	// Check device type and cache pointer to it.
	// This demo caches only first controller per type.
	// If multiple devices of the same type are available, real
	// application should cache and use all of them (if possible).
	// Each device can have multiple exposed controllers (but usually just 1).
	// In this simple caching scheme FindController() is used to find
	// first controller with matching interface-name. After that
	// controller's C++ type still needs to be checked by using
	// InterfaceCast() which is just a wrapper for C++ dynamic_cast operator
	// (it returns 0 on failure which automatically invalidates the target pointer).
	// Kernel ensures that SystemKeyboard & SystemMouse are always reported
	// before other devices.

	if(! pMouse) pMouse = InterfaceCast<Mouse>(hid.FindController(VW_INTERFACE_NAME_Mouse));
	if(! pKeyboard) pKeyboard = InterfaceCast<Keyboard>(hid.FindController(VW_INTERFACE_NAME_Keyboard));
	if(! pGameController) pGameController = InterfaceCast<GameController>(hid.FindController(VW_INTERFACE_NAME_GameController));
	if(! pPositionTracker) pPositionTracker = InterfaceCast<PositionTracker>(hid.FindController(VW_INTERFACE_NAME_PositionTracker));
	if(! pOrientationTracker) pOrientationTracker = InterfaceCast<OrientationTracker>(hid.FindController(VW_INTERFACE_NAME_OrientationTracker));
	if(! pGlove) pGlove = InterfaceCast<Glove>(hid.FindController(VW_INTERFACE_NAME_Glove));
}


//====================================================================
void  app_test1::EndConnectHumanInterfaceDevices()
{
	// Setup mouse properties
	if(pMouse) {
		pMouse->SetRelativeModeSensitivity(0.2, 0.2);
	}

	// Setup game-controller properties
	if(pGameController) {

		// this will make the end-position readings more stable
		float deadZone = 0.1f;
		float saturation = 0.9f;

		pGameController->SetAxisProperties(GameController::Axis_X, deadZone, saturation);
		pGameController->SetAxisProperties(GameController::Axis_Y, deadZone, saturation);
		pGameController->SetAxisProperties(GameController::Axis_RZ, deadZone, saturation);

		for(uint i = 0; i < pGameController->GetNumSliders(); i++) {
			pGameController->SetSliderProperties(i, deadZone, saturation);
		}

		// reverse some axes if necessary, or whatever other setup
		pGameController->SetAxisReverse(GameController::Axis_X, false);
		pGameController->SetAxisReverse(GameController::Axis_Y, false);
	}

	// Update view configuration (some devices may not function
	// after the reconfig takes place)

	SetViewConfig(viewConfig);

	// Cache async-controller handles (used for dialog communication)
	asyncSampleConfigs[AsyncController_Keyboard].controller = pKeyboard;
	asyncSampleConfigs[AsyncController_Mouse].controller = pMouse;
	asyncSampleConfigs[AsyncController_GameController].controller = pGameController;
	asyncSampleConfigs[AsyncController_OrientationTracker].controller = pOrientationTracker;

	// Update dialogs which contains some device-dependent controls.
	// This is necessary only if the dialog in question is currently opened,
	// because dialogs normally update the values themselves after they
	// transition to visible state.

	pOptionsDialog->UpdateControlDependencies();
}


//====================================================================
void  app_test1::SetupAsyncHIDSampling()
{
	// Activate/deactivate async sampling, called by framework
	// each time the devices are connected to video-window.
	// The demo also calls this method as a helper routine.

	for(uint i = 0; i < AsyncController_Count; i++) {
		if(! asyncSampleConfigs[i].controller) continue;

		AsyncSampleConfig& asc = asyncSampleConfigs[i];

		HumanInterfaceDevice& hid = asc.controller->GetParentHID();

		hid.ActivateAsyncSampling(asc.bAsync);
		hid.EnableMaxSampleRate(asc.bLimitRate);
		hid.SetMaxSampleRate(asc.maxRate);
		asc.maxRate = hid.GetMaxSampleRate();
	}
}


//====================================================================
void  app_test1::DisconnectHumanInterfaceDevices()
{
	pOptionsDialog->UpdateControlDependencies();

	// Invalidate pointers to all devices
	pMouse = 0;
	pKeyboard = 0;
	pGameController = 0;
	pPositionTracker = 0;
	pOrientationTracker = 0;
	pGlove = 0;

	for(uint i = 0; i < AsyncController_Count; i++) {
		asyncSampleConfigs[i].controller = 0;
	}
}


//====================================================================
void  app_test1::FilterVideoProfile(const VideoProfile& fullProfile,
										VideoProfile& outFilteredProfile)
{
}


//====================================================================
bool  app_test1::ConfirmVideoRenderer(const std::string& pluginName,
										const std::string& interfaceName)
{
	if(interfaceName == VW_INTERFACE_NAME_VideoRendererOpenGL) return true;
	if(interfaceName == VW_INTERFACE_NAME_VideoRendererDirect3D8) return true;

	// We will not explore the "unknown" in this demo
	return false;
}


//====================================================================
void  app_test1::QueryVideoConfig(std::string& pluginName, VideoConfig& vc,
									uint iReconfigCount, uint reconfigCode)
{
	olog << "app_test1 received QueryVideoConfig\n";
	olog << "reconfigCount = " << iReconfigCount << nl;
	olog << "reconfigCode = " << reconfigCode << nl;

	// At init, prefer OpenGL if plugin is available, otherwise leave it at kernel's choice.
	// Anyway, implement whatever selection logic is necessary for your application.

	if(! iReconfigCount) {
		std::string  tempVideoRendererPluginName;
		VideoConfig  tempVC;

		if(Kernel::Instance().ConstructClosestSafeVideoConfig(
									VW_INTERFACE_NAME_VideoRendererOpenGL, vc,
									tempVideoRendererPluginName, tempVC))
		{
			pluginName = tempVideoRendererPluginName;
			vc = tempVC;
		}
	}

	// Also not important (just testing). If window is resizable use size from
	// last video-config; this makes the window size constant across video-reconfig cycles.

	if(iReconfigCount  &&
		! vc.frameBufferConfig.fullscreen  &&  ! lastVideoConfig.frameBufferConfig.fullscreen  &&
		vc.resizable  &&  lastVideoConfig.resizable)
	{
		vc.displayModeConfig.width = lastVideoConfig.displayModeConfig.width;
		vc.displayModeConfig.height = lastVideoConfig.displayModeConfig.height;
	}
}


//====================================================================
void  app_test1::PostCreateMainWindow(MainWindowProperties& mwp, MainWindowGeometry& mwg,
								const std::string& vrPluginName, const VideoConfig& vc,
								uint iCreateCount)
{
	// Setup window text each time the window is recreated
	mwp.text = GetPluginInfo().GetPluginName();

	// Modify window geometry to your liking (or use config-files more likely).
	// By default, kernel centers the window on screen.
	if(! iCreateCount) {

		mwg.minSizeX = 350;
		mwg.minSizeY = 200;
//		mwg.positionX = 20;
//		mwg.positionY = 20;
		mwg.bMaximized = false;
	}
	else {
		mwg = lastMainWindowGeom;
	}
}


//====================================================================
void  app_test1::PreDestroyMainWindow(const MainWindowGeometry& mwg,
						const std::string& vrPluginName, const VideoConfig& vc)
{
	// store some data for later use
	lastMainWindowGeom = mwg;
	lastVideoConfig = vc;
}


//====================================================================
void  app_test1::OnVSyncUpdate(bool bVSyncEnabled)
{
	SyncGUIWithVideoRendererConfig();
}


//====================================================================
void  app_test1::ConnectVideoRenderer(VideoRenderer& vr)
{
	// Determine video-renderer type / cache video-renderer pointers
	pVRend = &vr;
	pVRendGL = InterfaceCast<VideoRendererOpenGL>(pVRend);
	pVRendD3D8 = InterfaceCast<VideoRendererDirect3D8>(pVRend);
	pGRend = &vr.GetGUIRenderer();

	// Update info-label & gui
	sRenderer = "Renderer: ";
	if(pVRendGL) sRenderer += "OpenGL";
	else if(pVRendD3D8) sRenderer += "Direct3D8";

	SyncGUIWithVideoRendererConfig();
}


//====================================================================
void  app_test1::DisconnectVideoRenderer()
{
	// Invalidate video-renderer pointers
	pVRend = 0;
	pVRendGL = 0;
	pVRendD3D8 = 0;
	pGRend = 0;

	SyncGUIWithVideoRendererConfig();
}


//====================================================================
void  app_test1::InitVideoRendererStates(bool bPostReset)
{
	// OpenGL specific
	if(pVRendGL) {
		glShadeModel(GL_SMOOTH);
		glEnable(GL_DEPTH_TEST);

		glEnable(GL_CULL_FACE);
		glCullFace(GL_BACK);
		glFrontFace(GL_CW);

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

		glEnable(GL_TEXTURE_2D);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

		glEnable(GL_LIGHTING);
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, color4f::ZERO);

		glEnable(GL_LIGHT0);
		glLightfv(GL_LIGHT0, GL_POSITION, vec4(0, 0, 0, 1));
		glLightfv(GL_LIGHT0, GL_AMBIENT, vec4::ZERO);
		glLightfv(GL_LIGHT0, GL_SPECULAR, vec4::ZERO);

		glMaterialfv(GL_FRONT, GL_AMBIENT, vec4::ZERO);
		glMaterialfv(GL_FRONT, GL_SPECULAR, vec4::ZERO);
		glMaterialfv(GL_FRONT, GL_EMISSION, vec4::ZERO);

		glColorMaterial(GL_FRONT, GL_DIFFUSE);
		glEnable(GL_COLOR_MATERIAL);
	}

	// Direct3D8 specific
	else if(pVRendD3D8) {
		IDirect3DDevice8& dev = *pVRendD3D8->GetD3DDevice();

		dev.SetPixelShader(0);
		dev.SetVertexShader(VertexD3D8::FVF);

		dev.SetRenderState(D3DRS_LIGHTING, TRUE);
		dev.SetRenderState(D3DRS_AMBIENT, 0);
		dev.SetRenderState(D3DRS_AMBIENTMATERIALSOURCE, D3DMCS_MATERIAL);
		dev.SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_COLOR1);
		dev.SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
		dev.SetRenderState(D3DRS_EMISSIVEMATERIALSOURCE, D3DMCS_MATERIAL);
		dev.SetRenderState(D3DRS_COLORVERTEX, TRUE);

		D3DMATERIAL8  material;
		material.Ambient = (D3DCOLORVALUE&)vec4::ZERO;
		material.Diffuse = (D3DCOLORVALUE&)vec4::ONE;
		material.Specular = (D3DCOLORVALUE&)vec4::ZERO;
		material.Emissive = (D3DCOLORVALUE&)vec4::ZERO;
		material.Power = 0;

		dev.SetMaterial(&material);

		::ZeroMemory(&lightD3D8, sizeof(D3DLIGHT8));
		lightD3D8.Type = D3DLIGHT_POINT;
		lightD3D8.Diffuse = (D3DCOLORVALUE&)vec4::ONE;
		lightD3D8.Specular = (D3DCOLORVALUE&)vec4::ZERO;
		lightD3D8.Ambient = (D3DCOLORVALUE&)vec4::ZERO;
		lightD3D8.Position = (D3DVECTOR&)vec3::ZERO;
		lightD3D8.Range = FLT_MAX;
		lightD3D8.Attenuation0 = 1;

		dev.SetLight(0, &lightD3D8);
		dev.LightEnable(0, TRUE);

		dev.SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
		dev.SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
		dev.SetRenderState(D3DRS_EDGEANTIALIAS, FALSE);
		dev.SetRenderState(D3DRS_ZBIAS, 0);
		dev.SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
		dev.SetRenderState(D3DRS_ZWRITEENABLE, TRUE);
		dev.SetRenderState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
		dev.SetRenderState(D3DRS_DITHERENABLE, FALSE);
		dev.SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD);
		dev.SetRenderState(D3DRS_FOGENABLE, FALSE);
		dev.SetRenderState(D3DRS_WRAP0, 0);
		dev.SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);
		dev.SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
		dev.SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		dev.SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

		dev.SetTextureStageState(0, D3DTSS_TEXCOORDINDEX, 0);
		dev.SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE);
		dev.SetTextureStageState(0, D3DTSS_ADDRESSU, D3DTADDRESS_CLAMP);
		dev.SetTextureStageState(0, D3DTSS_ADDRESSV, D3DTADDRESS_CLAMP);
		dev.SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR);
		dev.SetTextureStageState(0, D3DTSS_MINFILTER, D3DTEXF_LINEAR);
		if(gc_TextureUseMipmaps) {
			dev.SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTEXF_LINEAR);
		}
		else {
			dev.SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTEXF_NONE);
		}
		dev.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
		dev.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
		dev.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_CURRENT);

		dev.SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
		dev.SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
		dev.SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_CURRENT);

		DWORD numPasses;
		HRESULT hr = dev.ValidateDevice(&numPasses);

		d3d8_tools::D3DErrorCheckE(hr, "IDirect3DDevice8::ValidateDevice");

		dev.SetTransform(D3DTS_WORLD, d3d8_tools::ReinterpretCast(&mat4::IDENTITY));
		dev.SetTransform(D3DTS_VIEW, d3d8_tools::ReinterpretCast(&mat4::IDENTITY));
		dev.SetTransform(D3DTS_PROJECTION, d3d8_tools::ReinterpretCast(&mat4::IDENTITY));
	}
}


//====================================================================
void  app_test1::CreateVideoResources(bool bPostReset)
{
	if(bPostReset) {
		// This demo uses only api-managed resources that are persistent
		// across resets, so we do nothing here. If your application
		// uses non-api-managed resources (for example D3D8 video-memory
		// resources), make sure they are recreated here.
		return;
	}
	CreateBackgroundTextures();
}


//====================================================================
void  app_test1::ReleaseVideoResources(bool bPreReset)
{
	if(bPreReset) {
		// See also: CreateVideoResources()
		// If your application uses non-api-managed resources,
		// make sure they are released here, which is a prerequiste
		// for successful reset.
		return;
	}
	ReleaseBackgroundTextures();
}


//====================================================================
void  app_test1::GenericReconfig(uint iReconfigCount, uint reconfigCode)
{
	olog << "app_test1 received GenericReconfig\n";
	olog << "reconfigCount = " << iReconfigCount << nl;
	olog << "reconfigCode = " << reconfigCode << nl;

	// This callback is executed within kernel's configuration loop,
	// which makes it a safe place to do any kind of application-specific
	// dynamic reconfiguration including the gui. Let's create/destroy
	// something for the sake of argument.

	switch(reconfigCode) {

		case RC_CreateDynamicTestPane:
			if(! pDynamicTestPane) {
				pDynamicTestPane = new DynamicTestPane(this, CID_DestroyDynamicTestPane);
				pDynamicTestPane->SetPosition(100, 100);
				pDynamicTestPane->ActivateTopLevel(true);
			}
			break;

		case RC_DestroyDynamicTestPane:
			SafeDelete(pDynamicTestPane);
			break;
	}
}


//====================================================================
void  app_test1::InitializeSubsystems(uint iReconfigCount, uint reconfigCode)
{
	olog << "app_test1 received InitializeSubsystems\n";
	olog << "reconfigCount = " << iReconfigCount << nl;
	olog << "reconfigCode = " << reconfigCode << nl;
}


//====================================================================
void  app_test1::CleanupSubsystems(uint iReconfigCount, uint reconfigCode)
{
	olog << "app_test1 received CleanupSubsystems\n";
	olog << "reconfigCount = " << iReconfigCount << nl;
	olog << "reconfigCode = " << reconfigCode << nl;
}


//====================================================================
void  app_test1::ConnectSubsystemsToAppWindow(HWND hwnd, bool bFullscreen)
{
}


//====================================================================
void  app_test1::DisconnectSubsystemsFromAppWindow()
{
}


//====================================================================
bool  app_test1::CheckSubsystems()
{
	return true;
}


//====================================================================
void  app_test1::FixSubsystems()
{
}


//====================================================================
void  app_test1::OnKernelLevelChanged(eKernelLevel activeLevel)
{
}


//====================================================================
void  app_test1::OnWindowActive(bool bActive)
{
}


//====================================================================
void  app_test1::OnWindowResize(uint width, uint height)
{
	double aspectRatioWToH = double(width) / height;

	// Calculate help text position
	posHelpText.y = height - gc_HelpTextOffset;

	// Calculate event-log geometry
	dtpEventLog.positionTopLeft = vec2(width - gc_EventLogTextOffsetR, 0);
	rEventLogBgr.Set(width - gc_EventLogBgrOffsetR, 0, gc_EventLogBgrWidth, height);
	maxLogEvents = height / gc_EventLogTextHeight;

	// OpenGL specific
	if(pVRendGL) {
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gl_tools::Perspective(gc_FOVY, aspectRatioWToH, gc_NearPlane, gc_FarPlane);
		glMatrixMode(GL_MODELVIEW);
		glViewport(0, 0, width, height);
	}

	// Direct3D8 specific
	else if(pVRendD3D8) {
		IDirect3DDevice8& dev = *pVRendD3D8->GetD3DDevice();

		d3d8_tools::Perspective(dev, gc_FOVY, aspectRatioWToH, gc_NearPlane, gc_FarPlane);
		d3d8_tools::Viewport(dev, 0, 0, width, height, 0, 1);
	}
}


//====================================================================
void  app_test1::FrameBegin(double secsFrameTimeDelta)
{
}


//====================================================================
void  app_test1::FrameSampleInput()
{
	// SampleReadSentry must be put inside {} block to work correctly.
	// This snippet shows how to correctly sample the devices
	// in either synchronous or asynchronous sampling mode.
	// For standard devices you probably do not need this functionality,
	// just call SampleInputData() once per frame.
	// Please note that SampleInputData() is the
	// method of HumanInterfaceDevice rather than of HIDController.
	// This is due to the fact that any hardware device can expose
	// multiple logical controllers which are all sampled through
	// a single driver call. Also, the device may expose multiple
	// C++ interfaces for whatever reason. For devices with limited
	// sampling-speed that can affect the frame-rate you should consider
	// asynchronous sampling (uses different thread). In async-mode
	// sample-locking is required before reading the sampled data.
	// Notes: async-mode on system-keyboard/system-mouse works but
	// it slows down the application unnecessarily so avoid it.
	// Do not sample device twice per-frame, because they probably maintain
	// internal per-frame states, such as key-transitions. Sampling twice
	// nullifies transitions and you'll never get a key-down for example.
	// By default kernel auto-samples all devices if they run in sync-mode.
	// This can be turned off.

	//------------------------
	// Read data from keyboard
	//------------------------
	if(pKeyboard) {
		AsyncSampleReadSentry  asrs(*pKeyboard, false);

		// view control
		if(viewConfig.activeController == ViewController_Keyboard) {

			// read rotation speed
			bgr0RotSpeed.Set(0, 0, 0);

			if(pKeyboard->KeyPressed(Key_ArrowLeft))  bgr0RotSpeed.y += 1;
			if(pKeyboard->KeyPressed(Key_ArrowRight)) bgr0RotSpeed.y -= 1;

			if(pKeyboard->KeyPressed(Key_ArrowUp))    bgr0RotSpeed.x -= 1;
			if(pKeyboard->KeyPressed(Key_ArrowDown))  bgr0RotSpeed.x += 1;

			// reset background by key down
			if(pKeyboard->KeyDown(Key_Space)) bgr0Rot.Set(0, 0, 0);
		}

		// Take color screen-shot
		if(pKeyboard->KeyDown(Key_PrintScreen)) {

			AutoPtr<ImageBase> apImage;
			if(pVRend->CaptureFrameBuffer(apImage)) {

				// construct file-name
				std::string fileExt;
				DataCodecManager::Instance().GetDefaultFileFormatExtension(DataCategory_Image, miscConfig.screenshotFormat, fileExt, ".image");

				std::string fileName = sProfileDirectoryName + gc_szScreenShotFileName + ToString(iScreenShotSerial) + "." + fileExt;
				iScreenShotSerial++;

				// allow image-codec to overwrite files
				NamedParameterList nplSave = DataCodecManager::Instance().GetEncoderDefaultParamList(DataCategory_Image);
				nplSave.Insert(NamedParameter(data_codec_parameters::Param_FileOverwrite, true));

				// do save image
				SaveImage(*apImage, fileName, miscConfig.screenshotFormat, &nplSave);
				olog << "Saved screenshot as: " << fileName << std::endl;
			}
			AddEventToLog("Screenshot");
		}
	}

	//---------------------
	// Read data from mouse
	//---------------------
	if(pMouse) {
		AsyncSampleReadSentry  asrs(*pMouse, false);

		// view control
		if(viewConfig.activeController == ViewController_Mouse) {

			// regulate sensitivity by wheel
			float delta = pMouse->GetDeltaWheel();
			if(delta) {
				float s;
				pMouse->GetRelativeModeSensitivity(s, s);

				s += delta * 0.01;
				Clamp<float>(s, 0.1, 0.5);

				pMouse->SetRelativeModeSensitivity(s, s);
			}

			bgr0RotSpeed.Set(pMouse->GetDeltaY(), -pMouse->GetDeltaX(), 0);

			// reset background by button press
			if(pMouse->ButtonDown(MouseButton_Left))  bgr0Rot.y = 0;
			if(pMouse->ButtonDown(MouseButton_Right)) bgr0Rot.x = 0;
		}
	}

	//-------------------------------
	// Read data from game-controller
	//-------------------------------
	if(pGameController) {
		AsyncSampleReadSentry  asrs(*pGameController);

		// view control
		if(viewConfig.activeController == ViewController_GameController) {

			// regulate sensitivity by slider
			float maxSpeed = 0.5f * (1 + pGameController->GetSliderPosition(0));

			bgr0RotSpeed.y = - maxSpeed * pGameController->GetAxisPosition(GameController::Axis_X);
			bgr0RotSpeed.x = + maxSpeed * pGameController->GetAxisPosition(GameController::Axis_Y);

			// reset background by button press
			if(pGameController->ButtonDown(0)) bgr0Rot.y = 0;
			if(pGameController->ButtonDown(1)) bgr0Rot.x = 0;
		}
	}

	//-----------------------------------
	// Read data from orientation-tracker
	//-----------------------------------
	if(pOrientationTracker) {
		AsyncSampleReadSentry  asrs(*pOrientationTracker);

		// view control
		if(viewConfig.bCombineTrackerReadings) {

			// Demo will read data completely pre-processed by OrientationTracker-interface.
			// This interface internally employs a number of modifiers that can be controlled.
			// You can also get the raw data in the form of Euler angles or quaternions.

			pOrientationTracker->GetOrientation(trackerU, trackerV, trackerN);
		}
	}
}


//====================================================================
void  app_test1::FrameUpdateStates(double secsFrameTimeDelta)
{
	// By default, kernel auto-dispatches gui-manager events after
	// FrameUpdateStates(). Kernel can also call this before
	// FrameUpdateStates() or this feature can be turned off if you
	// need more control of input-processing order. If this is the case
	// call gui::Manager::Instance().DispatchInputEvents() once per frame.
	// Do not call it multiple times or gui will not function correctly.

	// Animate some params
	PingPongValue(secsFrameTimeDelta, lightIntensitySpeed, lightIntensity, gc_LightIntensityMin, gc_LightIntensityMax);
	PingPongValue(secsFrameTimeDelta, bgr1RotSpeed, bgr1Rot, gc_Bgr1RotMin, gc_Bgr1RotMax);

	// No active view controller, animate background
	if(viewConfig.activeController == ViewController_None) {

		PingPongValue(secsFrameTimeDelta, bgr0AlphaSpeed, bgr0Alpha, gc_Bgr0AlphaMin, gc_Bgr0AlphaMax);
		PingPongValue(secsFrameTimeDelta, bgr0RotSpeed, bgr0Rot, gc_Bgr0RotMin, gc_Bgr0RotMax);
	}

	// Background controlled by active view-controller
	else {
		// Reverse vertical axis value if requested
		if(viewConfig.bReverseViewControllerVerticalAxis) {
			FlipSign(bgr0RotSpeed.x);
		}

		// Update background rotation
		bgr0Rot += secsFrameTimeDelta * bgr0RotSpeed * gc_Bgr0RotFactorViewController;

		// Maintain lowest possible range to avoid drift
		RemapAngleTo180DegRange(bgr0Rot.y);
		RemapAngleTo90DegRange(bgr0Rot.x);
		RemapAngleTo90DegRange(bgr0Rot.z);

		Clamp(bgr0Rot.x, -gc_Bgr0MaxPitchViewController, gc_Bgr0MaxPitchViewController);

		// Generate orientation-tracker transforms suitable for rendering
		if(viewConfig.bCombineTrackerReadings) {

			// Tracker returns standard-RHS axes which can be directly used
			// as a view transform. To makes things more interesting, demo will
			// combine standard view controller readings (keyboard for example)
			// with head-tracker readings to provide possibility of full background pan.
			// So...back-convert to head-pitch-roll. You might wonder why not
			// use the raw HPR values directly. No reason, if you like them raw -
			// use them raw, however the OrientationTracker-interface provides some
			// convenient functionality, such as reverse modifiers.

			mat4  matTracker;
			GenerateRotateMV(matTracker, trackerU, trackerV, trackerN);

			FactorEulerHPR_MV(matTracker, trackerRot.y, trackerRot.x, trackerRot.z);
		}
	}

	// Combine tracker/view-controller readings
	finalViewRot = bgr0Rot;

	if(viewConfig.activeController != ViewController_None  &&  viewConfig.bCombineTrackerReadings)
	{
		finalViewRot += trackerRot;
	}

	// Animate help-text
	float windowWidth = gui::Manager::Instance().GetWindowWidth();

	posHelpText.x -= fHelpSpeed * secsFrameTimeDelta;
	if(fHelpSpeed >= 0  &&  posHelpText.x + rHelpTextBgr.width < 0) {
		posHelpText.x = windowWidth;
	}
	else if(fHelpSpeed < 0  &&  posHelpText.x > windowWidth) {
		posHelpText.x = - rHelpTextBgr.width;
	}

	// Animate info-labels
	PingPongValue(secsFrameTimeDelta, fInfoLabelAlphaSpeed, fInfoLabelAlpha, 0.1, 1.4);
	PingPongValue(secsFrameTimeDelta, speedInfoLabels, posInfoLabels, gc_InfoLabelPosMin, gc_InfoLabelPosMax);

	// Animate rubberband trail
	if(bDrawRubberbandTrail) {
		rubberbandTrailColor.a -= gc_RubberbandTrailFadeSpeed * secsFrameTimeDelta;
		if(rubberbandTrailColor.a <= 0) {
			bDrawRubberbandTrail = false;
		}
	}
}


//====================================================================
void  app_test1::FramePreRenderVideo()
{
}


//====================================================================
void  app_test1::FrameRenderVideo()
{
	//------------------------------------------------------------------
	// By default, kernel draws gui after FrameRenderVideo(). This feature
	// can be turned off if you need more control of drawing order.
	// If this is the case call gui::Manager::Instance().Draw() once per frame.
	// Keep in mind that this routine uses gui-renderer internally, so it calls
	// gui::Renderer::Begin() at entry and gui::Renderer::End() at exit.
	// This methods may store/restore large amount of graphics api states,
	// so they should be called once per frame to minimize performance-hit.
	// In another words, if you will be using gui-renderer for drawing something
	// independently of gui-manager (such as text), you should use call sequence
	// similar to this:
	// {
	//     DrawStuffByUsingLowLevelAPICalls1();
	//
	//     VideoRenderer&  vr = ...
	//     gui::Manager&   gm = ...
	//     gui::Renderer&  gr = ...
	//
	//     gr.Begin(); //prepare gui-renderer for new cycle
	//
	//     DrawStuffByUsingGUIRendererCalls1();
	//
	//     gm.Draw();  //draw gui through manager, called by kernel by default
	//
	//     DrawStuffByUsingGUIRendererCalls2();
	//
	//     gr.End();   //finish gui-renderer cycle, called by kernel by default
	//
	//     DrawStuffByUsingLowLevelAPICalls2();
	//
	//     vr.PresentBackBuffer(); //flip buffers, called by kernel by default
	// }
	// Whatever sequence you use, make sure that low-level-api calls and
	// gui-renderer calls are separated by gui::Renderer::Begin()/End().
	//------------------------------------------------------------------

	// VW_PROFILE_BLOCK measures block time (ctor/dtor based)
	// Profile blocks are "picked-up" by framework-internal profiler.
	{
		VW_PROFILE_BLOCK("app_test1::ClearFrameBuffer");

		// Clear color/depth buffer & set viewport (as this is a common task,
		// gui-renderer provides simple abstraction of this calls which
		// are completely independent of Begin/End cycles)

		pGRend->SetViewport(gui::Renderer::ViewportParams(vec2::ZERO, pGRend->GetWindowSize()));
		pGRend->ClearBuffers(gui::Renderer::ClearParams(true, color4b::WHITE, true, 1));
	}

	// Draw animated background (use low-level renderers for this task)
	DrawBackground();

	// Draw some info on main window (use gui-renderer for this task)
	VW_PROFILE_BLOCK("app_test1::DrawOverlayGUI");

	pGRend->Begin();

	// Draw event-log
	if(bEventLogShow) {
		pGRend->DrawRectangle(rEventLogBgr);

		dtpEventLog.positionTopLeft.y = 0;

		std::list<std::string>::const_iterator it = eventLog.begin();
		while(it != eventLog.end()) {
			const std::string& s = *it++;
			pGRend->DrawText(*pFont, s, dtpEventLog);
			dtpEventLog.positionTopLeft.y += gc_EventLogTextHeight;
		}
	}

	// Draw scrolling help text
	if(bShowHelp) {

		dtpHelpText.positionTopLeft = posHelpText;
		rHelpTextBgr.left = posHelpText.x - gc_HelpTextBgrHalfExtend;
		rHelpTextBgr.top = posHelpText.y;

		pGRend->DrawRectangle(rHelpTextBgr);
		pGRend->DrawText(*pFont, sHelpText, dtpHelpText);
	}

	// Draw info-labels
	if(bShowInfoLabels) {
		float   a = Clamped<float>(fInfoLabelAlpha, 0, 1);
		color4b cShadow = color4b(0, 0, 0, a * 160);
		color4b cText = color4b(255, 255, 255, a * 192);

		float lineHeight = dtpInfoLabels.tm.textHeight * 1.5;
		vec2  pos = posInfoLabels;
		vec2  shadow = vec2(2, 2);

		DrawShadowText(sRenderer, dtpInfoLabels, *pGRend, *pFont, pos, shadow, cText, cShadow);
		pos.y += lineHeight;

		DrawShadowText(sActiveController, dtpInfoLabels, *pGRend, *pFont, pos, shadow, cText, cShadow);
		pos.y += lineHeight;

		DrawShadowText(sHeadTracker, dtpInfoLabels, *pGRend, *pFont, pos, shadow, cText, cShadow);
	}

	// Draw HPR labels
	if(bShowHPRLabel) {
		color4b cShadow = color4b(0, 0, 0, 224);
		color4b cText = color4b(255, 255, 255, 224);

		float lineHeight = dtpInfoLabels.tm.textHeight * 1.5;
		vec2  pos = gc_HPRLabelPos;
		vec2  shadow = vec2(1, 1);

		sHPR = "H:" + ToStringFix(finalViewRot.y, 6, 1);
		DrawShadowText(sHPR, dtpHPRLabel, *pGRend, *pFont, pos, shadow, cText, cShadow);
		pos.y += lineHeight;

		sHPR = "P:" + ToStringFix(finalViewRot.x, 6, 1);
		DrawShadowText(sHPR, dtpHPRLabel, *pGRend, *pFont, pos, shadow, cText, cShadow);
		pos.y += lineHeight;

		sHPR = "R:" + ToStringFix(finalViewRot.z, 6, 1);
		DrawShadowText(sHPR, dtpHPRLabel, *pGRend, *pFont, pos, shadow, cText, cShadow);
	}

	// Draw rubberband trail
	if(bDrawRubberbandTrail) {
		rRubberbandTrail.SetColor(rubberbandTrailColor);
		pGRend->DrawRectangle(rRubberbandTrail);
	}

	// Backbuffer-flip & similar boring work is handled by kernel,
	// unless turned-off explicitly.
}


//====================================================================
void  app_test1::FrameRenderArea(const gui::InterleavedRenderArea& area)
{
	// Called by InterleavedRenderArea gui-components to draw themselves.
	// If area is currently hidden this is not called, as simple as that.
	// If you dont want to mess with pointer comparisons, each area has
	// a code by which you can decide what to draw here. Do not use
	// gui-renderer methods here except those that can be called outside
	// Begin/End. Also, do not call Begin/End yourself. InterleavedRenderArea
	// is designed specifically for purpose of interleaving low-level-api
	// calls with gui-manager driven hierarchy drawing (for example drawing
	// a scene in a gui-frame), so if you need to use gui-renderer primitives
	// use them somewhere else.

	VW_PROFILE_BLOCK("app_test1::FrameRenderArea");

	if(area.GetAreaCode() == AreaCode_InterleavedTest) {

		// this calls are valid, SetViewport & ClearBuffers are Begin/End independent
		bool bSafeToRender = pGRend->SetViewport(gui::Renderer::ViewportParams(
										area.GetAbsolutePosition(), area.GetSize()));

		pGRend->ClearBuffers(gui::Renderer::ClearParams(true, color4b(0, 0, 0),
							true, 1, false, 0, true,
							gui::Rectangle(area.GetAbsolutePosition(), area.GetSize())));

		if(bSafeToRender) {
			DrawBackgroundInterleaved();
		}
		return;
	}
}


//====================================================================
void  app_test1::FramePostRenderVideo()
{
}


//====================================================================
void  app_test1::FrameEnd()
{
}


//====================================================================
bool  app_test1::GUIOnCommand(uint commandID)
{
	AddEventToLog("Command " + ToString(commandID - CID_Dummy));

	// Handle commands sent by gui-components
	switch(commandID) {

	case CID_OpenConsole: {
		pConsole->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenProfilerDialog: {
		pProfilerControlDialog->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenFrameStatsPane: {
		pFrameStatsPane->ActivateTopLevel(true);
		return true;
	}
	case CID_VSync: {
		bool bVSyncEnabled = Kernel::Instance().GetActiveVideoRenderer().GetVideoConfig().videoHints.vSync;
		Kernel::Instance().GetActiveVideoRenderer().UpdateVSync(! bVSyncEnabled);
		return true;
	}
	case CID_OpenVideoConfigDialog: {
		pVideoConfigDialog->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenPixelOffsetPane: {
		pPixelOffsetControlPane->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenHIDConfigDialog: {
		pHIDConfigDialog->ActivateTopLevel(true);
		return true;
	}
	case CID_HIDReconfigCycle: {
		Kernel& k = Kernel::Instance();
		DirectInputConfig  diConfig;
		k.GetActiveDirectInputConfig(diConfig);
		k.RequestHIDReconfig(diConfig);
		return true;
	}
	case CID_OpenMouseStatePane: {
		pMouseStatePane->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenKeyboardStatePane: {
		pKeyboardStatePane->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenGameControllerStatePane: {
		pGameControllerStatePane->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenOrientationTrackerStatePane: {
		pOrientationTrackerStatePane->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenPositionTrackerStatePane: {
		pPositionTrackerStatePane->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenGloveStatePane: {
		pGloveStatePane->ActivateTopLevel(true);
		return true;
	}
	case CID_VSD3D8Cleanup: {
		Kernel::Instance().SetPluginParameter(VW_PLUGIN_NAME_Std_VideoSubsystem_Direct3D8,
				NamedParameter(VW_PLUGIN_PARAM_NAME_VS_DIRECT3D8_DestroyWindowBeforeD3DObjectRelease,
								pMenuItemVSD3D8Cleanup->IsOn()));
		return true;
	}
	case CID_OpenFontTest: {
		pFontTest->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenClockTest: {
		pClockTestPane->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenToolBarTest1: {
		pToolBarTest1->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenToolBarTest2: {
		pToolBarTest2->ActivateTopLevel(true);
		return true;
	}
	case CID_CreateDynamicTestPane: {
		Kernel::Instance().RequestGenericReconfig(RC_CreateDynamicTestPane);
		return true;
	}
	case CID_DestroyDynamicTestPane: {
		Kernel::Instance().RequestGenericReconfig(RC_DestroyDynamicTestPane);
		return true;
	}
	case CID_AppSubsysReconfigCycle: {
		Kernel::Instance().RequestSubsystemReconfig();
		return true;
	}
	case CID_OpenDemoOptions: {
		pOptionsDialog->ActivateTopLevel(true);
		return true;
	}
	case CID_OpenDemoAbout: {
		// This is the way to specify that component should run modal.
		// Manager maintains modal stack, so stacked run-modal invocations are allowed.
		// When active modal component is hidden, manager automatically pops modal stack.

		pAboutDialog->RunModal();
		return true;
	}
	case CID_LightColor: {
		UpdateLightColorFromGUI();
		return true;
	}
	case CID_EventLogShow: {
		Flip(bEventLogShow);
		SyncGUIWithEventLogStates();
		return true;
	}
	case CID_EventLogQueryCursor: {
		Flip(bEventLogQueryCursor);
		SyncGUIWithEventLogStates();
		return true;
	}
	case CID_EventLogMouseMove: {
		Flip(bEventLogMouseMove);
		SyncGUIWithEventLogStates();
		return true;
	}
	case CID_RubberBand: {
		// Draw rubberband trail on rubberband release,
		// not important - just cool.

		if(! pRubberBand->IsVisible()) {
			pRubberBand->GetLastArea(rRubberbandTrail);
			rubberbandTrailColor = gc_RubberbandTrailColor;
			bDrawRubberbandTrail = true;
		}
		return true;
	}
	case CID_ExitProgram: {
		Kernel::Instance().RequestShutdown();
		return true;
	}
	}
	return false;
}


//====================================================================
bool  app_test1::GUIOnActivate(bool bActivate, bool bByMouse)
{
	std::string s = bActivate ? "OnActivate" : "OnDeActivate";
	if(bByMouse) s.append("ByMouse");
	AddEventToLog(s);
	return false;
}


//====================================================================
bool  app_test1::GUIOnMouseCapture(bool bCaptureBegin)
{
	AddEventToLog(bCaptureBegin ? "OnMouseCaptureBegin" : "OnMouseCaptureEnd");
	return false;
}


//====================================================================
bool  app_test1::GUIOnMouseEnterExit(bool bEnter, const vec2& mousePos)
{
	AddEventToLog(bEnter ? "OnMouseEnter" : "OnMouseExit");
	return false;
}


//====================================================================
bool  app_test1::GUIOnMouseQueryCursor(const gui::Cursor* &pCursor, const vec2& mousePos)
{
	if(bEventLogQueryCursor) {
		AddEventToLog("MouseQueryCursor");
	}
	return false;
}


//====================================================================
bool  app_test1::GUIOnMouseMove(bool bHover, double hoverTimeSecs, const vec2& mousePos)
{
	if(gui::Manager::Instance().IsMouseCapturedByApplication()) {
		AddEventToLog("MouseMoveCaptured");
	}
	else if(bEventLogMouseMove) {
		AddEventToLog(bHover ? "MouseHover" : "MouseMove");
	}
	return false;
}


//====================================================================
bool  app_test1::GUIOnMouseWheel(int delta, const vec2& mousePos)
{
	AddEventToLog("MouseWheel");
	return false;
}


//====================================================================
bool  app_test1::GUIOnMouseButton(bool bDown, eMouseButton buttonCode, bool bDoubleClick, uint repeatCount, const vec2& mousePos)
{
	std::string s = bDown ? "MouseButtonDown" : "MouseButtonUp";
	if(bDoubleClick) s.append("Double");
	else if(repeatCount) s.append("Repeat");
	AddEventToLog(s);

	// Exit mouse relative-mode if active
	if(pMouse->IsActiveRelativeMode()  &&  bDown) {
		pMouse->ActivateRelativeMode(false);
		return true;
	}

	if(! bDown  ||  repeatCount) return false;

	switch(buttonCode) {

		// Start rubberband on left-click
		case MouseButton_Left:
			bDrawRubberbandTrail = false;
			if(pMenuItemEnableRubberband->IsOn()) {
				pRubberBand->Begin(mousePos);
			}
			return true;

		// Bring-up the context-menu on right-click
		case MouseButton_Right:
			pMenuPaneContext->ShowAsContextMenu(true, mousePos);
			return true;
	}
	return false;
}


//====================================================================
bool  app_test1::GUIOnKeyboardQueryFocus(bool bFocusByMouse, eMouseButton buttonCode, bool& bWantFocus, bool& bNeedCharacterData)
{
	AddEventToLog(bFocusByMouse ? "KeyboardQueryFocusByMouse" : "KeyboardQueryFocus");
	return false;
}


//====================================================================
bool  app_test1::GUIOnKeyboardFocus(bool bGotFocus)
{
	AddEventToLog(bGotFocus ? "KeyboardGotFocus" : "KeyboardLostFocus");
	return false;
}


//====================================================================
bool  app_test1::GUIOnKeyboardKey(bool bDown, eKey keyCode, uint repeatCount, char ch)
{
	std::string s = bDown ? "KeyDown" : "KeyUp";
	if(repeatCount) s.append("Repeat");
	AddEventToLog(s);

	// process only first key-down
	if(! bDown  ||  repeatCount) return false;

	switch(keyCode) {

		// Help on/off
		case Key_F1: {
			Flip(bShowHelp);
			AddEventToLog("ShowHelp " + ToString(bShowHelp));
			return true;
		}

		// Info-labels on/off
		case Key_F2: {
			Flip(bShowInfoLabels);
			AddEventToLog("ShowInfoLabels " + ToString(bShowInfoLabels));
			return true;
		}

		// HPR-label on/off
		case Key_F3: {
			Flip(bShowHPRLabel);
			AddEventToLog("ShowHPRLabel " + ToString(bShowHPRLabel));
			return true;
		}

		// Show menu-bar if hidden / Exit program
		case Key_Escape: {

			if(gui::Manager::Instance().IsKeyModifierPressed(KeyModifier_Shift)) {
				Kernel::Instance().RequestShutdown();
				return true;
			}
			else {
				pMenuBar->ShowTopLevel(true);
				AddEventToLog("ShowMenu");
			}
			break;
		}

		// Reset head tracker
		case Key_R: {
			if(pOrientationTracker) {
				if(! pOrientationTracker->ResetOrientation()) {
					pOrientationTracker->ResetHead();
				}
			}
			AddEventToLog("ResetTracker");
			return true;
		}

		// Combine tracker readings
		case Key_T: {
			Flip(viewConfig.bCombineTrackerReadings);
			SetViewConfig(viewConfig);
			AddEventToLog("CombineTracker " + ToString(viewConfig.bCombineTrackerReadings));
			return true;
		}

		// Cycle active controllers
		case Key_C: {
			reinterpret_cast<uint&>(viewConfig.activeController)++;
			if(viewConfig.activeController > ViewController_GameController) {
				viewConfig.activeController = ViewController_None;
			}
			SetViewConfig(viewConfig);
			AddEventToLog("ActiveController " + ToString(viewConfig.activeController));
			return true;
		}
	}

	// exit mouse relative-mode
	if(viewConfig.activeController == ViewController_Mouse) {

		viewConfig.activeController = ViewController_None;
		SetViewConfig(viewConfig);
		AddEventToLog("DisableMouseController");
		return true;
	}
	return false;
}


//====================================================================
void  app_test1::AddEventToLog(const std::string& eventName)
{
	eventLog.push_back(eventName);
	while(eventLog.size() > maxLogEvents) {
		eventLog.pop_front();
	}
}


//====================================================================
void  app_test1::SyncGUIWithEventLogStates()
{
	pMenuItemEventLogShow->SetOn(bEventLogShow);
	pMenuItemEventLogQueryCursor->SetOn(bEventLogQueryCursor);
	pMenuItemEventLogQueryCursor->SetEnabled(bEventLogShow);
	pMenuItemEventLogMouseMove->SetOn(bEventLogMouseMove);
	pMenuItemEventLogMouseMove->SetEnabled(bEventLogShow);
}


//====================================================================
void  app_test1::SyncGUIWithVideoRendererConfig()
{
	bool bVSyncEnabled = pVRend ? pVRend->GetVideoConfig().videoHints.vSync : false;
	pMenuItemVSync->SetOn(bVSyncEnabled);
}


//====================================================================
void  app_test1::UpdateLightColorFromGUI()
{
	if(pMenuItemLightWhite->IsSelected())      lightColor = color4f::WHITE;
	else if(pMenuItemLightRed->IsSelected())   lightColor = color4f::RED;
	else if(pMenuItemLightGreen->IsSelected()) lightColor = color4f::GREEN;
	else if(pMenuItemLightBlue->IsSelected())  lightColor = color4f::BLUE;
}


//====================================================================
void  app_test1::CreateBackgroundTextures()
{
	// Make sure previous textures are released
	ReleaseBackgroundTextures();

	// Recreate textures
	for(uint i = 0; i < gc_NumImages; i++) {

		// OpenGL specific
		if(pVRendGL) {

			apTextureGL[i].Assign(new gl_tools::Texture2D(
					apImage[i]->GetSampleFormat(), gc_TextureUseMipmaps,
					apImage[i]->GetNumRows(), apImage[i]->GetNumColumns()));

			// pass image-data to low-level-api
			apTextureGL[i]->LoadLevels(*apImage[i]);

			// setup parameters bound to GL-texture-object
			apTextureGL[i]->BindToActiveTextureUnit();

			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

			if(gc_TextureUseMipmaps) {
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
			}
			else {
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			}
		}

		// Direct3D8 specific
		else if(pVRendD3D8) {

			apTextureD3D8[i].Assign(new d3d8_tools::Texture2D(
					*pVRendD3D8->GetD3DDevice(),
					apImage[i]->GetSampleFormat(), gc_TextureUseMipmaps,
					apImage[i]->GetNumRows(), apImage[i]->GetNumColumns()));

			// pass image-data to low-level-api
			apTextureD3D8[i]->LoadLevels(*apImage[i]);
		}
	}
}


//====================================================================
void  app_test1::ReleaseBackgroundTextures()
{
	for(uint i = 0; i < gc_NumImages; i++) {
		apTextureD3D8[i].SafeDelete();
		apTextureGL[i].SafeDelete();
	}
}


//====================================================================
void  app_test1::DrawBackground()
{
	VW_PROFILE_BLOCK("app_test1::DrawBackground");

	// Animate light
	color4f lightDiffuse = lightColor * lightIntensity;
	lightDiffuse.a = 1;

	// Animate background alpha
	float finalBgr0Alpha = bgr0Alpha;

	if(viewConfig.activeController != ViewController_None) {
		finalBgr0Alpha = 1;
	}

	// OpenGL specific
	if(pVRendGL) {

		// feed animated light params
		glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse);
		color4f color = color4f::ONE;

		// feed background 1
		apTextureGL[3]->BindToActiveTextureUnit();
		{
			gl_tools::MatrixStackSentry  mss(GL_MODELVIEW);
			gl_tools::View(bgr1Rot);

			FeedSphereSectionVerticesGL(apVerticesSphereSection1,
					gc_SphereSection1SubdivH, gc_SphereSection1SubdivV, color);
		}
		// feed background 0
		color.a = finalBgr0Alpha;

		// feed sphere section multiple times to display full 360-degrees area
		for(uint i = 0; i < 3; i++) {

			apTextureGL[i]->BindToActiveTextureUnit();

			gl_tools::MatrixStackSentry  mss(GL_MODELVIEW);
			gl_tools::View(finalViewRot + vec3(0, i * 120, 0));

			FeedSphereSectionVerticesGL(apVerticesSphereSection0,
					gc_SphereSection0SubdivH, gc_SphereSection0SubdivV, color);
		}
	}

	// Direct3D8 specific
	else if(pVRendD3D8) {

		IDirect3DDevice8& dev = *pVRendD3D8->GetD3DDevice();

		// feed animated light params
		lightD3D8.Diffuse = (D3DCOLORVALUE&)lightDiffuse;
		dev.SetLight(0, &lightD3D8);

		dev.BeginScene();

		// feed background 1
		dev.SetTexture(0, apTextureD3D8[3]->GetD3DBaseTexture());

		d3d8_tools::View(dev, bgr1Rot);

		FeedSphereSectionVertexBufferD3D8(dev, apUPVertexBufferD3D8[1],
					gc_SphereSection1SubdivH, gc_SphereSection1SubdivV);

		// feed background 0

		// update vertex alpha
		UpdateSphereSectionVertexAlphaD3D8(
					apUPVertexBufferD3D8[0], apVertexAlphaD3D8[0],
					vertexCountD3D8[0], finalBgr0Alpha);

		// feed sphere section multiple times to display full 360-degrees area
		for(uint i = 0; i < 3; i++) {

			dev.SetTexture(0, apTextureD3D8[i]->GetD3DBaseTexture());

			d3d8_tools::View(dev, finalViewRot + vec3(0, i * 120, 0));

			FeedSphereSectionVertexBufferD3D8(dev, apUPVertexBufferD3D8[0],
					gc_SphereSection0SubdivH, gc_SphereSection0SubdivV);
		}

		dev.SetTexture(0, 0);
		dev.EndScene();
	}
}


//====================================================================
void  app_test1::DrawBackgroundInterleaved()
{
	VW_PROFILE_BLOCK("app_test1::DrawBackgroundInterleaved");

	vec3 viewRot;
	viewRot.x = +0.5f * ((interleavedViewConfig.posVert + interleavedViewConfig.pageVert * 0.5f) - gc_SphereSection2AngleV * 0.5f);
	viewRot.y = -0.5f * ((interleavedViewConfig.posHorz + interleavedViewConfig.pageHorz * 0.5f) - gc_SphereSection2AngleH * 0.5f);
	viewRot.z = 0;

	// OpenGL specific
	if(pVRendGL) {

		// feed light params
		glLightfv(GL_LIGHT0, GL_DIFFUSE, vec4::ONE);

		// feed background 2
		apTextureGL[4]->BindToActiveTextureUnit();
		{
			gl_tools::MatrixStackSentry  mss(GL_MODELVIEW);
			gl_tools::View(viewRot);

			FeedSphereSectionVerticesGL(apVerticesSphereSection2,
				gc_SphereSection2SubdivH, gc_SphereSection2SubdivV, color4f::ONE);
		}
	}

	// Direct3D8 specific
	else if(pVRendD3D8) {

		IDirect3DDevice8& dev = *pVRendD3D8->GetD3DDevice();

		// feed light params
		lightD3D8.Diffuse = (D3DCOLORVALUE&)vec4::ONE;
		dev.SetLight(0, &lightD3D8);

		dev.BeginScene();

		// feed background 2
		dev.SetTexture(0, apTextureD3D8[4]->GetD3DBaseTexture());

		d3d8_tools::View(dev, viewRot);

		FeedSphereSectionVertexBufferD3D8(dev, apUPVertexBufferD3D8[2],
					gc_SphereSection2SubdivH, gc_SphereSection2SubdivV);

		dev.SetTexture(0, 0);
		dev.EndScene();
	}
}


//====================================================================
// Construct master vertex data, also used for OpenGL
// immediate-mode rendering.
//====================================================================
void  app_test1::GenerateSphereSectionVertices(AutoPtr<Vertex>& dst,
								uint subdivH, uint subdivV,
								float maxAngleH, float maxAngleV, float radius)
{
	uint numRows = subdivV + 1;
	uint numCols = subdivH + 1;

	dst.Assign(new Vertex[numRows * numCols]);

	// generate RHS strips at +z, top-to-bottom, left-to-right
	vec2 angleRef(- maxAngleV * 0.5f,    + maxAngleH * 0.5f);
	vec2 angleInc(+ maxAngleV / subdivV, - maxAngleH / subdivH);
	vec2 texCoordsRef(0, 1);
	vec2 texCoordsInc(1.0 / subdivH, -1.0 / subdivV);

	vec2 angle = angleRef;
	vec2 texCoords = texCoordsRef;

	uint iIndex = 0;
	for(uint iV = 0; iV < numRows; iV++) {

		angle.y = angleRef.y;
		texCoords.x = texCoordsRef.x;

		for(uint iH = 0; iH < numCols; iH++) {

			float sH, sP, cH, cP;
			SinCosDeg(angle.y, sH, cH);
			SinCosDeg(angle.x, sP, cP);

			vec3 normPos = vec3(cP * sH, - sP, cP * cH);

			Vertex vertex;
			vertex.position  = + normPos * radius;
			vertex.normal    = - normPos;
			vertex.texCoords = + texCoords;

			// fade section edges
			if(iH == 0  ||  iH == subdivH  ||  iV == 0  ||  iV == subdivV) {
				vertex.alpha = 0;
			}
			else {
				vertex.alpha = 1;
			}

			dst[iIndex++] = vertex;

			angle.y += angleInc.y;
			texCoords.x += texCoordsInc.x;
		}
		angle.x += angleInc.x;
		texCoords.y += texCoordsInc.y;
	}
}


//====================================================================
void  app_test1::FeedSphereSectionVerticesGL(const AutoPtr<Vertex>& src,
								uint subdivH, uint subdivV, color4f color)
{
	color4f diffuseColor = color;

	uint numCols = subdivH + 1;

	for(uint iV = 0; iV < subdivV; iV++) {

		uint iT = iV * numCols;
		uint iB = iT + numCols;

		glBegin(GL_TRIANGLE_STRIP);

		for(uint iH = 0; iH < numCols; iH++) {

			uint stripPair[2] = { iB, iT }; //front-face CW
			for(uint iP = 0; iP < 2; iP++) {

				const Vertex& s = src[stripPair[iP]];

				diffuseColor.a = s.alpha * color.a;

				glColor4fv(diffuseColor);
				glTexCoord2fv(s.texCoords);
				glNormal3fv(s.normal);
				glVertex3fv(s.position);
			}
			iT++;
			iB++;
		}
		glEnd();
	}
}


//====================================================================
// Construct vertices suitable for D3D8 rendering.
//====================================================================
void  app_test1::GenerateSphereSectionVerticesD3D8(const AutoPtr<Vertex>& src,
							AutoPtr<VertexD3D8>& dst, AutoPtr<float>& dstAlpha,
							uint& vertexCount, uint subdivH, uint subdivV)
{
	uint numCols = subdivH + 1;

	vertexCount = 2 * numCols * subdivV;
	dst.Assign(new VertexD3D8[vertexCount]);
	dstAlpha.Assign(new float[vertexCount]);

	uint iDst = 0;

	// transform to LHS strips
	for(uint iV = 0; iV < subdivV; iV++) {

		uint iT = iV * numCols;
		uint iB = iT + numCols;

		for(uint iH = 0; iH < numCols; iH++) {

			uint stripPair[2] = { iB, iT }; //front-face CW
			for(uint iP = 0; iP < 2; iP++) {

				const Vertex& s = src[stripPair[iP]];
				VertexD3D8& d = dst[iDst];
				float& dAlpha = dstAlpha[iDst++];

				d.position = vec3(- s.position.x, s.position.y, s.position.z);
				d.normal = - d.position;
				d.diffuse = color4b(255, 255, 255, 255);
				d.texCoords = vec2(s.texCoords.x, 1 - s.texCoords.y);
				dAlpha = s.alpha;
			}
			iT++;
			iB++;
		}
	}
}


//====================================================================
void  app_test1::UpdateSphereSectionVertexAlphaD3D8(AutoPtr<VertexD3D8>& dst,
							const AutoPtr<float>& refAlpha, uint vertexCount,
							float alphaMultiplier)
{
	Clamp<float>(alphaMultiplier, 0, 1);

	for(uint i = 0; i < vertexCount; i++) {
		dst[i].diffuse = color4b(color4f(1, 1, 1, refAlpha[i] * alphaMultiplier));
	}
}


//====================================================================
void  app_test1::FeedSphereSectionVertexBufferD3D8(IDirect3DDevice8& dev,
						const AutoPtr<VertexD3D8>& src, uint subdivH, uint subdivV)
{
	uint numTrianglesPerStrip = subdivH * 2;
	uint numVerticesPerStrip = (subdivH + 1) * 2;
	uint iIndex = 0;

	for(uint iV = 0; iV < subdivV; iV++) {

		dev.DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, numTrianglesPerStrip,
								src + iIndex, sizeof(VertexD3D8));

		iIndex += numVerticesPerStrip;
	}
}

