

//--------------------------------------------------------------------
#include "private\dip_8.h"
#include "BaseTools\Debug.h"

using namespace vertexware;


//====================================================================
dip_8::dip_8()
{
	iObject = 0;
}


//====================================================================
dip_8::~dip_8()
{
	Shutdown();
}


//====================================================================
void  dip_8::Initialize()
{
	if(iObject) return;
	HRESULT hr = DirectInput8Create(GetModuleHandle(0), DIRECTINPUT_VERSION,
						IID_IDirectInput8, reinterpret_cast<void**>(&iObject), 0);
	if(FAILED(hr)) {
		VW_THROW(DirectInputProxyException, "Failed to create DirectInput8 object.");
	}
}


//====================================================================
void  dip_8::Shutdown()
{
	win_utils::SafeRelease(iObject);
}


//====================================================================
IDirectInput8*  dip_8::GetDirectInputObject()
{
	return iObject;
}


//====================================================================
const GUID&  dip_8::GetGuidSysKeyboard()
{
	return GUID_SysKeyboard;
}


//====================================================================
const GUID&  dip_8::GetGuidSysMouse()
{
	return GUID_SysMouse;
}


//====================================================================
const DIDATAFORMAT&  dip_8::GetDataFormatKeyboard()
{
	return c_dfDIKeyboard;
}


//====================================================================
const DIDATAFORMAT&  dip_8::GetDataFormatMouse()
{
	return c_dfDIMouse;
}


//====================================================================
const DIDATAFORMAT&  dip_8::GetDataFormatMouse2()
{
	return c_dfDIMouse2;
}


//====================================================================
const DIDATAFORMAT&  dip_8::GetDataFormatJoystick()
{
	return c_dfDIJoystick;
}


//====================================================================
const DIDATAFORMAT&  dip_8::GetDataFormatJoystick2()
{
	return c_dfDIJoystick2;
}


