

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "HIDControllers\Glove.h"
#include "BaseTools\Memory.h"
#include "vendor_sdk\fglove.h"

using namespace vertexware;


//====================================================================
class DataGlove : public HumanInterfaceDevice, public Glove
{
public:
	DataGlove(fdGlove* gloveHandle, uint iComPort);
	virtual ~DataGlove();


	//-------------------------------------
	// HumanInterfaceDevice implementation.
	//-------------------------------------
	virtual  uint            GetNumControllers() { return 1; }
	virtual  HIDController&  GetController(uint i) { return *this; }

	virtual  void  ConnectToAppWindow(TopLevelWindow* pAppWindow,
									HWND hwndAppWindow, bool bFullscreen);

	virtual  void  DisconnectFromAppWindow();

	virtual  bool  SampleInputData();


protected:
	//-------------------------------------
	// HumanInterfaceDevice implementation.
	//-------------------------------------
	virtual  void  OnUseDirectInput(bool bUseDI);


private:
	void   ReportAvailableSensors(const int* pHWSensors, uint count);
	void   InitSensorMaps();

	// unsigned 12-bits [0, 4095] to [0, 1]
	__forceinline  float  NormRawValue(ushort rawValue) {
		return float(rawValue) * float(1.0 / 4095.0);
	}


private:
	fdGlove*       gloveHandle;
	uint           iComPort;
	EfdGloveTypes  iModel;
	EfdGloveHand   iHand;
	uint           iNumSensors;

	Buffer<int>     sensorMapToHW;
	Buffer<ushort>  rawSensorValues;
};


