

//--------------------------------------------------------------------
#include "private\hidd0_5dt_dataglove.h"
#include "DataGlove.h"
#include "BaseTools\String.h"

using namespace vertexware;


//====================================================================
#define  DEFAULT_DRIVER_PRIORITY  888111


//====================================================================
hidd0_5dt_dataglove::hidd0_5dt_dataglove()
{
}


//====================================================================
hidd0_5dt_dataglove::~hidd0_5dt_dataglove()
{
}


//====================================================================
uint  hidd0_5dt_dataglove::GetDefaultDriverPriority()
{
	return DEFAULT_DRIVER_PRIORITY;
}


//====================================================================
void  hidd0_5dt_dataglove::ClearCache()
{
	availableGloves.clear();
	gloveComPorts.clear();
}


//====================================================================
bool  hidd0_5dt_dataglove::CanHandleDevice(const DirectInputDeviceInstanceInfo& didii)
{
	// DirectInput drivers not provided by 5DT
	return false;
}


//====================================================================
uint  hidd0_5dt_dataglove::ProbeDevices()
{
	// open all available gloves
	for(uint iComPort = 1; iComPort <= 8; iComPort++) {

		std::string  sPort = "COM" + ToString(iComPort);

		// probe port and check result
		fdGlove*  gloveHandle = fdOpen(const_cast<char*>(sPort.c_str()));

		if(gloveHandle) {
			// store glove info
			availableGloves.push_back(gloveHandle);
			gloveComPorts.push_back(iComPort);
		}
	}

	// return number of available gloves
	return availableGloves.size();
}


//====================================================================
HumanInterfaceDevice*  hidd0_5dt_dataglove::CreateDevice(uint i)
{
	// create glove object for each available glove-handle
	HumanInterfaceDevice* hid = new DataGlove(availableGloves[i], gloveComPorts[i]);
	return hid;
}


