

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "HIDControllers\OrientationTracker.h"
#include "vendor_sdk\isense.h"

using namespace vertexware;


//====================================================================
class InterSenseOrientationTracker : public HumanInterfaceDevice,
										public OrientationTracker
{
public:
	InterSenseOrientationTracker(ISD_TRACKER_HANDLE trackerHandle);
	virtual ~InterSenseOrientationTracker();


	//-------------------------------------
	// HumanInterfaceDevice implementation.
	//-------------------------------------
	virtual  uint            GetNumControllers() { return 1; }
	virtual  HIDController&  GetController(uint i) { return *this; }

	virtual  void  ConnectToAppWindow(TopLevelWindow* pAppWindow,
									HWND hwndAppWindow, bool bFullscreen);

	virtual  void  DisconnectFromAppWindow();

	virtual  bool  SampleInputData();


protected:
	//-------------------------------------
	// HumanInterfaceDevice implementation.
	//-------------------------------------
	virtual  void  OnUseDirectInput(bool bUseDI);

	//-----------------------------------
	// OrientationTracker implementation.
	//-----------------------------------
	virtual  bool  DoResetOrientation();
	virtual  bool  DoResetHead();
	virtual  bool  DoResetPitch();
	virtual  bool  DoResetRoll();
	virtual  bool  DoChangeSamplingMode(eSamplingMode mode);


private:
	// intersense-driver requires 1-based station numbering: [1, MaxStations]
	uint  GetDriverStationNumber() const { return (stationNumber + 1); }
	void  AdjustInternalHPRModifiers();


private:
	ISD_TRACKER_HANDLE     trackerHandle;
    ISD_TRACKER_INFO_TYPE  trackerInfo;
	ISD_TRACKER_DATA_TYPE  trackerData;

	uint  stationNumber; //0-based

	// internal modifiers
	float  modifierH;
	float  modifierP;
	float  modifierR;
};

