

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "Framework\HIDDriver0.h"
#include "vendor_sdk\isense.h"
#include <vector>

using namespace vertexware;


//====================================================================
// Currently this driver handles only station-1 orientation
// for each tracker. Position and multiple stations are
// not handled for now.
//====================================================================
class hidd0_intersense_tracker : public HIDDriver0
{
public:
	hidd0_intersense_tracker();
	virtual ~hidd0_intersense_tracker();


	//--------------------------
	// HIDDriver implementation.
	//--------------------------
	virtual  uint  GetDefaultDriverPriority();

	virtual  void  ClearCache();


	//---------------------------
	// HIDDriver0 implementation.
	//---------------------------
	virtual  bool  CanHandleDevice(const DirectInputDeviceInstanceInfo& didii);

	virtual  uint  ProbeDevices();

	virtual  HumanInterfaceDevice*  CreateDevice(uint i);


private:
	std::vector<ISD_TRACKER_HANDLE>  availableTrackers;
};


