

//--------------------------------------------------------------------
#include "private\hidd8_generic_gamecontroller.h"
#include "private\GenericGameController.h"

using namespace vertexware;


//====================================================================
#define  DEFAULT_DRIVER_PRIORITY  2000222000


//====================================================================
hidd8_generic_gamecontroller::hidd8_generic_gamecontroller()
{
}


//====================================================================
hidd8_generic_gamecontroller::~hidd8_generic_gamecontroller()
{
}


//====================================================================
uint  hidd8_generic_gamecontroller::GetDefaultDriverPriority()
{
	return DEFAULT_DRIVER_PRIORITY;
}


//====================================================================
void  hidd8_generic_gamecontroller::ClearCache()
{
	availableGameControllers.clear();
}


//====================================================================
bool  hidd8_generic_gamecontroller::CanHandleDevice(const DirectInputDeviceInstanceInfo8& didii)
{
	// handle only suitable device-types
	uint devType = GET_DIDEVICE_TYPE(didii.dwDevType);

	switch(devType) {
		case DI8DEVTYPE_1STPERSON:
		case DI8DEVTYPE_DRIVING:
		case DI8DEVTYPE_FLIGHT:
		case DI8DEVTYPE_GAMEPAD:
		case DI8DEVTYPE_JOYSTICK:
		case DI8DEVTYPE_SUPPLEMENTAL:
			// store device info
			availableGameControllers.push_back(didii);
			return true;
	}

	// not my device
	return false;
}


//====================================================================
uint  hidd8_generic_gamecontroller::GetNumDevices()
{
	// return number of available game-controllers
	return availableGameControllers.size();
}


//====================================================================
HumanInterfaceDevice*  hidd8_generic_gamecontroller::CreateDevice(uint i, DirectInputProxy8& dip)
{
	// create generic-game-controller object for each available DirectInput-device
	HumanInterfaceDevice* hid = new GenericGameController(dip, availableGameControllers[i]);
	return hid;
}


