

//--------------------------------------------------------------------
#include "BaseTools\Color.h"
#include "BaseTools\Serializers.h"


//********************************************************************
namespace vertexware {


//====================================================================
const color4f  color4f::ZERO       = color4f(0.f, 0.f, 0.f, 0.f);
const color4f  color4f::ONE        = color4f(1.f, 1.f, 1.f, 1.f);
const color4f  color4f::BLACK      = color4f(0.f, 0.f, 0.f, 1.f);
const color4f  color4f::DARK_GRAY  = color4f(.25f, .25f, .25f, 1.f);
const color4f  color4f::GRAY       = color4f(.5f, .5f, .5f, 1.f);
const color4f  color4f::LIGHT_GRAY = color4f(.75f, .75f, .75f, 1.f);
const color4f  color4f::WHITE      = color4f(1.f, 1.f, 1.f, 1.f);
const color4f  color4f::RED        = color4f(1.f, 0.f, 0.f, 1.f);
const color4f  color4f::GREEN      = color4f(0.f, 1.f, 0.f, 1.f);
const color4f  color4f::BLUE       = color4f(0.f, 0.f, 1.f, 1.f);
const color4f  color4f::CYAN       = color4f(0.f, 1.f, 1.f, 1.f);
const color4f  color4f::MAGENTA    = color4f(1.f, 0.f, 1.f, 1.f);
const color4f  color4f::YELLOW     = color4f(1.f, 1.f, 0.f, 1.f);


//====================================================================
std::ostream& __fastcall operator<=(std::ostream &os, const color4f& c)
{
	os <= c.r <= c.g <= c.b <= c.a;
	return os;
}


//====================================================================
std::istream& __fastcall operator>=(std::istream &is, color4f& c)
{
	is >= c.r >= c.g >= c.b >= c.a;
	return is;
}


//====================================================================
const color4b  color4b::ZERO       = color4f(0, 0, 0, 0);
const color4b  color4b::ONE        = color4f(255, 255, 255, 255);
const color4b  color4b::BLACK      = color4b(0, 0, 0, 255);
const color4b  color4b::DARK_GRAY  = color4b(64, 64, 64, 255);
const color4b  color4b::GRAY       = color4b(128, 128, 128, 255);
const color4b  color4b::LIGHT_GRAY = color4b(192, 192, 192, 255);
const color4b  color4b::WHITE      = color4b(255, 255, 255, 255);
const color4b  color4b::RED        = color4b(255, 0, 0, 255);
const color4b  color4b::GREEN      = color4b(0, 255, 0, 255);
const color4b  color4b::BLUE       = color4b(0, 0, 255, 255);
const color4b  color4b::CYAN       = color4b(0, 255, 255, 255);
const color4b  color4b::MAGENTA    = color4b(255, 0, 255, 255);
const color4b  color4b::YELLOW     = color4b(255, 255, 0, 255);


//====================================================================
std::ostream& __fastcall operator<=(std::ostream &os, const color4b& c)
{
	os <= c.a <= c.r <= c.g <= c.b;
	return os;
}


//====================================================================
std::istream& __fastcall operator>=(std::istream &is, color4b& c)
{
	is >= c.a >= c.r >= c.g >= c.b;
	return is;
}


//********************************************************************
}//namespace vertexware


