

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\Types.h"
#include <string>


//********************************************************************
namespace vertexware {


//********************************************************************
namespace platform_info {


//====================================================================
// General.
//====================================================================
VW_COMMON_API
std::string __fastcall  GetMachineName();


//====================================================================
VW_COMMON_API
std::string __fastcall  GetUserName();


//====================================================================
// Environment variable expansion, form is %variableName%
// Do not pass multiple variables.
// Returns false if variable cannot be expanded.
//====================================================================
VW_COMMON_API
bool __fastcall ExpandEnvironmentVariable(const std::string& envVar, std::string& out);


//====================================================================
// Operating system version.
//====================================================================
VW_COMMON_API
bool __fastcall  GetOperatingSystemVersion(
						uint* pMajor, uint* pMinor, uint* pBuild,
						uint* pServicePackMajor, uint* pServicePackMinor);


//====================================================================
VW_COMMON_API
bool __fastcall  RunningOnWindows2000();


//====================================================================
VW_COMMON_API
bool __fastcall  RunningOnWindowsXP();


//====================================================================
VW_COMMON_API
std::string __fastcall GetOperatingSystemDescription();


//====================================================================
// Display.
//====================================================================
VW_COMMON_API
bool __fastcall  GetWorkArea(uint* pWidth, uint* pHeight, uint* pLeft, uint* pTop);


//====================================================================
VW_COMMON_API
bool __fastcall  GetDesktopDisplayMode(DEVMODE& dm);


//====================================================================
VW_COMMON_API
bool __fastcall  GetDesktopDisplayMode(uint* pWidth, uint* pHeight,
										uint* pBitsPerPixel, uint* pRefreshFrequency);


//====================================================================
VW_COMMON_API
std::string __fastcall  GetDesktopDisplayModeDescription();


//********************************************************************
}//namespace platform_info


//********************************************************************
}//namespace vertexware

