

//--------------------------------------------------------------------
#include "BaseTools\Types.h"
#include <sstream>
#include <iomanip>


//********************************************************************
namespace vertexware {


//====================================================================
UID::UID()
{
	sequence[0] = 0;
	sequence[1] = 0;
	sequence[2] = 0;
	sequence[3] = 0;
}


//====================================================================
UID::UID(const uint* a)
{
	sequence[0] = a[0];
	sequence[1] = a[1];
	sequence[2] = a[2];
	sequence[3] = a[3];
}


//====================================================================
UID::UID(uint a0, uint a1, uint a2, uint a3)
{
	sequence[0] = a0;
	sequence[1] = a1;
	sequence[2] = a2;
	sequence[3] = a3;
}


//====================================================================
bool  UID::operator==(const UID& rhs) const
{
	return
	(sequence[0] == rhs.sequence[0])  &&
	(sequence[1] == rhs.sequence[1])  &&
	(sequence[2] == rhs.sequence[2])  &&
	(sequence[3] == rhs.sequence[3]);
}


//====================================================================
std::string  UID::ToString() const
{
	const char sep = '-';

	std::ostringstream oss;
	oss.setf(std::ios::hex, std::ios::basefield);
	oss.setf(std::ios::uppercase);
	oss.fill('0');

	oss << '[';
	oss << std::setw(8) << sequence[0] << sep;
	oss << std::setw(8) << sequence[1] << sep;
	oss << std::setw(8) << sequence[2] << sep;
	oss << std::setw(8) << sequence[3];
	oss << ']';

	return oss.str();
}


//********************************************************************
}//namespace vertexware

