

//--------------------------------------------------------------------
#include "DataObjects\Sample.h"
#include "BaseTools\Constructs.h"
#include "BaseTools\String.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace sample_formats {


//====================================================================
std::string __fastcall MapSampleFormatToName(uint sampleFormat)
{
	switch(sampleFormat) {
		case SampleFormat_L8: return "L8";
		case SampleFormat_A8: return "A8";
		case SampleFormat_A8L8: return "A8L8";
		case SampleFormat_A4R4G4B4: return "A4R4G4B4";
		case SampleFormat_A1R5G5B5: return "A1R5G5B5";
		case SampleFormat_X8R8G8B8: return "X8R8G8B8";
		case SampleFormat_A8R8G8B8: return "A8R8G8B8";
	}
	return "unknown";
}


//====================================================================
uint __fastcall MapNameToSampleFormat(const std::string& sampleFormatName)
{
	std::string name = UpperCase(sampleFormatName);

	if(name == "L8") return SampleFormat_L8;
	if(name == "A8") return SampleFormat_A8;
	if(name == "A8L8") return SampleFormat_A8L8;
	if(name == "A4R4G4B4") return SampleFormat_A4R4G4B4;
	if(name == "A1R5G5B5") return SampleFormat_A1R5G5B5;
	if(name == "X8R8G8B8") return SampleFormat_X8R8G8B8;
	if(name == "A8R8G8B8") return SampleFormat_A8R8G8B8;

	return SampleFormat_Invalid;
}


//********************************************************************
}//namespace sample_formats


//********************************************************************
}//namespace vertexware


