

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "DataObjects\SignalIO.h"
#include "BaseTools\WinUtils.h"


//********************************************************************
namespace vertexware {


//====================================================================
// GDI+ wrapper image-encoder.
// Format/optional-parameter support:
// 1) TIFF (use-compression)
// 2) JPEG (quality)
// 3) PNG
// 4) BMP
//====================================================================
class VW_COMMON_API ImageEncoderGdiplus : public ImageEncoder
{
public:
	ImageEncoderGdiplus();

	virtual  bool  SaveImage(const ImageBase& sourceImage,
							const std::string& fileName,
							const std::string& fileFormat,
							const NamedParameterList& parameterList);

private:
	win_utils::GdiplusGuard  gpg;
};


//====================================================================
// GDI+ wrapper image-decoder.
// Format/optional-parameter support:
// 1) TIFF
// 2) JPEG
// 3) PNG
// 4) BMP
//====================================================================
class VW_COMMON_API ImageDecoderGdiplus : public ImageDecoder
{
public:
	ImageDecoderGdiplus();

	virtual  ImageBase*  LoadImage(const std::string& fileName,
								const NamedParameterList& parameterList);

private:
	win_utils::GdiplusGuard  gpg;
};


//********************************************************************
}//namespace vertexware


