

//--------------------------------------------------------------------
#include "Framework\Application.h"
#include "BaseTools\Stream.h"
#include "GUI\GUI_Manager.h"
#include "GUI\GUI_InterleavedRenderArea.h"


//********************************************************************
namespace vertexware {


//====================================================================
Application::StartupInfo::StartupInfo()
{
}


//====================================================================
void  Application::StartupInfo::DumpPaths(std::ostream& os, uint tabLevel) const
{
	TabEffector te(tabLevel);

	os << te << "ProcessDirectory....: " << processDir << nl;
	os << te << "UserHomeDirectory...: " << userHomeDir << nl;
	os << te << "UserProfileDirectory: " << userProfileDir << nl;
	os << te << "AppProfileDirectory.: " << appProfileDir << nl;
	os << te << "AppLogFilename......: " << appLogFilename << nl;
}


//====================================================================
Application::StartupResult::StartupResult()
{
	bUseProfileDir = true;
	bAutoCreateProfileDir = true;
	bShowLogAndExit = false;
}


//====================================================================
void  Application::StartupResult::DumpPaths(std::ostream& os, uint tabLevel) const
{
	TabEffector te(tabLevel);

	os << te << "ProcessDirectory...: " << processDir << nl;
	os << te << "AppProfileDirectory: " << appProfileDir << nl;
	os << te << "AppLogFilename.....: " << appLogFilename << nl;
	os << te << "AppWindowText......: " << appWindowText << nl;
}


//====================================================================
Application::AutoInitInfo::AutoInitInfo()
{
	bDeveloperMode = false;

	bShowGUICursor = true;
	bShowSystemCursor = false;

	bAutoRegisterStandardSignalCodecs = true;
	bAutoRegisterStandardImageCodecs = true;
	bAutoRegisterStandardVolumeCodecs = true;

	bAutoRegisterStandardTileTextures = true;
	bAutoRegisterStandardFonts = true;
	bAutoRegisterStandardCursors = true;

	bDumpSystemFonts = false;
	bDumpSignalCodecs = true;
	bDumpImageCodecs = true;
	bDumpVolumeCodecs = true;
	bDumpTileTextures = true;
	bDumpFonts = true;
	bDumpShaders = true;
	bDumpCursors = true;
	bDumpComponentHierarchy = false;
	bDumpCycleQueue = false;
}


//====================================================================
Application::Application()
{
}


//====================================================================
Application::~Application()
{
}


//====================================================================
UID  Application::GetApplicationUID()
{
	return UID();
}


//====================================================================
void  Application::BeginStartup(const StartupInfo& si, StartupResult& sr)
{
}


//====================================================================
void  Application::QueryAutoInit(AutoInitInfo& aii)
{
}


//====================================================================
void  Application::Initialize()
{
}


//====================================================================
void  Application::EndStartup()
{
}


//====================================================================
void  Application::Cleanup(bool bCleanExit, const FailureDesc& fd)
{
}


//====================================================================
bool  Application::ConfirmGenericExtension(const std::string& pluginName,
							const std::string& genericExtensionInterfaceName)
{
	return false;
}


//====================================================================
void  Application::ConnectGenericExtensions()
{
}


//====================================================================
bool  Application::ConfirmDirectInputVersion(uint directInputVersion)
{
	return true;
}


//====================================================================
bool  Application::ConfirmHIDDriver(const std::string& pluginName,
									uint defaultDriverPriority,
									uint& outDriverPriority)
{
	return true;
}


//====================================================================
void  Application::QueryHIDConfig(DirectInputConfig& diConfig,
								uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
bool  Application::QueryIgnoreHIDDriver(const std::string& pluginName)
{
	return false;
}


//====================================================================
void  Application::BeginConfirmHumanInterfaceDevices()
{
}


//====================================================================
bool  Application::ConfirmHumanInterfaceDevice(HumanInterfaceDevice& hid)
{
	return true;
}


//====================================================================
void  Application::EndConfirmHumanInterfaceDevices()
{
}


//====================================================================
void  Application::BeginConnectHumanInterfaceDevices(const DirectInputConfig& diConfig)
{
}


//====================================================================
void  Application::ConnectHumanInterfaceDevice(HumanInterfaceDevice& hid)
{
}


//====================================================================
void  Application::EndConnectHumanInterfaceDevices()
{
}


//====================================================================
void  Application::SetupAsyncHIDSampling()
{
}


//====================================================================
void  Application::DisconnectHumanInterfaceDevices()
{
}


//====================================================================
void  Application::FilterVideoProfile(const VideoProfile& fullProfile,
									VideoProfile& outFilteredProfile)
{
}


//====================================================================
bool  Application::ConfirmVideoRenderer(const std::string& pluginName,
										const std::string& interfaceName)
{
	return true;
}


//====================================================================
void  Application::QueryVideoConfig(std::string& vrPluginName, VideoConfig& vc,
									uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
void  Application::PostCreateMainWindow(MainWindowProperties& mwp, MainWindowGeometry& mwg,
									const std::string& vrPluginName, const VideoConfig& vc,
									uint iCreateCount)
{
}


//====================================================================
void  Application::PreDestroyMainWindow(const MainWindowGeometry& mwg,
						const std::string& vrPluginName, const VideoConfig& vc)
{
}


//====================================================================
void  Application::OnVSyncUpdate(bool bVSyncEnabled)
{
}


//====================================================================
void  Application::ConnectVideoRenderer(VideoRenderer& vr)
{
}


//====================================================================
void  Application::DisconnectVideoRenderer()
{
}


//====================================================================
void  Application::InitVideoRendererStates(bool bPostReset)
{
}


//====================================================================
void  Application::CreateVideoResources(bool bPostReset)
{
}


//====================================================================
void  Application::ReleaseVideoResources(bool bPreReset)
{
}


//====================================================================
void  Application::GenericReconfig(uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
void  Application::InitializeSubsystems(uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
void  Application::CleanupSubsystems(uint iReconfigCount, uint reconfigCode)
{
}


//====================================================================
void  Application::ConnectSubsystemsToAppWindow(HWND hwnd, bool bFullscreen)
{
}


//====================================================================
void  Application::DisconnectSubsystemsFromAppWindow()
{
}


//====================================================================
bool  Application::CheckSubsystems()
{
	return true;
}


//====================================================================
void  Application::FixSubsystems()
{
}


//====================================================================
void  Application::OnKernelLevelChanged(eKernelLevel activeLevel)
{
}


//====================================================================
void  Application::OnWindowActive(bool bActive)
{
}


//====================================================================
void  Application::OnWindowResize(uint width, uint height)
{
}


//====================================================================
void  Application::FrameBegin(double secsFrameTimeDelta)
{
}


//====================================================================
void  Application::FrameSampleInput()
{
}


//====================================================================
void  Application::FrameUpdateStates(double secsFrameTimeDelta)
{
}


//====================================================================
void  Application::FramePreRenderVideo()
{
}


//====================================================================
void  Application::FrameRenderVideo()
{
	gui::Renderer& gr = Kernel::Instance().GetActiveVideoRenderer().GetGUIRenderer();
	gr.ClearBuffers(gui::Renderer::ClearParams());
}


//====================================================================
void  Application::FrameRenderArea(const gui::InterleavedRenderArea& area)
{
}


//====================================================================
void  Application::FramePostRenderVideo()
{
}


//====================================================================
void  Application::FrameEnd()
{
}


//====================================================================
bool  Application::HandleMessage(gui::Message& msg)
{
	using namespace gui;
	switch(msg.messageID) {

	case MID_Command: {
		MsgPtr<Message_Command> m(msg);
		return GUIOnCommand(m->GetCommandID());
	}
	case MID_MouseCapture: {
		MsgPtr<Message_MouseCapture> m(msg);
		return GUIOnMouseCapture(m->GetCaptureBegin());
	}
	case MID_Activate: {
		MsgPtr<Message_Activate> m(msg);
		return GUIOnActivate(true, m->GetActivateByMouse());
	}
	case MID_Deactivate: {
		MsgPtr<Message_Deactivate> m(msg);
		return GUIOnActivate(false, m->GetDeactivateByMouse());
	}
	case MID_MouseEnterExit: {
		MsgPtr<Message_MouseEnterExit> m(msg);
		return GUIOnMouseEnterExit(m->GetMouseEnter(), m->GetMousePosition());
	}
	case MID_MouseQueryCursor: {
		MsgPtr<Message_MouseQueryCursor> m(msg);
		const Cursor* pCursor = m->GetCursor();
		bool retVal = GUIOnMouseQueryCursor(pCursor, m->GetMousePosition());
		m->SetCursor(pCursor);
		return retVal;
	}
	case MID_MouseMove: {
		MsgPtr<Message_MouseMove> m(msg);
		return GUIOnMouseMove(m->GetHover(), m->GetHoverTimeSeconds(), m->GetMousePosition());
	}
	case MID_MouseWheel: {
		MsgPtr<Message_MouseWheel> m(msg);
		return GUIOnMouseWheel(m->GetWheelDelta(), m->GetMousePosition());
	}
	case MID_MouseButton: {
		MsgPtr<Message_MouseButton> m(msg);
		return GUIOnMouseButton(m->GetButtonDown(), m->GetButtonCode(), m->GetDoubleClick(), m->GetRepeatCount(), m->GetMousePosition());
	}
	case MID_KeyboardQueryFocus: {
		MsgPtr<Message_KeyboardQueryFocus> m(msg);
		bool bWantFocus = m->GetWantFocus();
		bool bNeedCharacterData = m->GetNeedCharacterData();
		bool retVal = GUIOnKeyboardQueryFocus(m->GetFocusByMouse(), m->GetButtonCode(), bWantFocus, bNeedCharacterData);
		m->SetWantFocus(bWantFocus);
		m->SetNeedCharacterData(bNeedCharacterData);
		return retVal;
	}
	case MID_KeyboardFocus: {
		MsgPtr<Message_KeyboardFocus> m(msg);
		return GUIOnKeyboardFocus(m->GetGotFocus());
	}
	case MID_KeyboardKey: {
		MsgPtr<Message_KeyboardKey> m(msg);
		return GUIOnKeyboardKey(m->GetKeyDown(), m->GetKeyCode(), m->GetRepeatCount(), m->GetCharData());
	}
	}
	return false;
}


//====================================================================
ApplicationPluginDescriptor::ApplicationPluginDescriptor(const PluginInfo& pi)
	:
	PluginDescriptor(PluginInfo(pi, PluginType_Application))
{
}


//********************************************************************
}//namespace vertexware

