

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\Profiler.h"
#include "BaseTools\Singleton.h"


//********************************************************************
namespace vertexware {


//====================================================================
class VW_COMMON_API FrameworkProfiler : public Profiler
{
VW_DECLARE_SINGLETON( FrameworkProfiler );

public:
	FrameworkProfiler();
	~FrameworkProfiler();
};


//====================================================================
class VW_COMMON_API FrameworkProfileRootBlock : public ProfileRootBlock
{
public:
	__forceinline FrameworkProfileRootBlock()
		:
		ProfileRootBlock(FrameworkProfiler::Instance())
	{ }
};


//====================================================================
class VW_COMMON_API FrameworkProfileBlock : public ProfileBlock
{
public:
	__forceinline FrameworkProfileBlock(const char* pBlockName)
		:
		ProfileBlock(FrameworkProfiler::Instance(), pBlockName)
	{ }
};


//====================================================================
#define  VW_PROFILE_ROOT_BLOCK \
	FrameworkProfileRootBlock  frameworkProfileRootBlock;


//====================================================================
#define  VW_PROFILE_BLOCK( BlockName ) \
	FrameworkProfileBlock  frameworkProfileBlock(BlockName);


//********************************************************************
}//namespace vertexware


