

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "Framework\HIDDriver.h"
#include "Framework\DirectInputProxy8.h"
#include "private\vw_common_exports.h"


//********************************************************************
namespace vertexware {


//====================================================================
// DirectInput8-dependent device-driver.
//====================================================================
class VW_COMMON_API HIDDriver8 : public HIDDriver
{
public:
	//--------------------------
	// HIDDriver implementation.
	//--------------------------
	virtual  std::string  GetHIDDriverInterfaceName();

	//-------------------------------------------------------------
	// Return true if driver can handle given device.
	// If true is returned, also store device-info internally,
	// which should be used to create the device in CreateDevice().
	// Exceptions NOT allowed.
	//-------------------------------------------------------------
	virtual  bool  CanHandleDevice(const DirectInputDeviceInstanceInfo8& didii) = 0;

	//-----------------------------------------------------------------
	// Return number of handled devices. If CanHandledDevice() returned
	// true <n> times, this function should return <n>. However, this
	// is not enforced by kernel.
	//-----------------------------------------------------------------
	virtual  uint  GetNumDevices() = 0;

	//-------------------------------------------------
	// Create device at given index. If GetNumDevices()
	// returned <n>, this function is called <n> times.
	// Exceptions NOT allowed.
	//-------------------------------------------------
	virtual  HumanInterfaceDevice*  CreateDevice(uint i, DirectInputProxy8& dip) = 0;


protected:
	HIDDriver8();
};


//====================================================================
#define  VW_INTERFACE_NAME_HIDDriver8   "HIDDriver8"


//********************************************************************
}//namespace vertexware


