

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI\GUI_Renderer.h"
#include <iosfwd>


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui {


//********************************************************************
namespace std_tile_textures {


//====================================================================
VW_COMMON_API  VW_DECLARE_CONSTANT( char*, TileTextureName_Set0 );
VW_COMMON_API  VW_DECLARE_CONSTANT( char*, DefaultFileName_Set0 );


//====================================================================
VW_COMMON_API
bool __fastcall RegisterTileTexture_Set0(std::ostream& os,
						bool bMultiLevel = true,
						const std::string& registerUnderName = TileTextureName_Set0,
						const std::string& loadFromFile = DefaultFileName_Set0);


//====================================================================
// Name................: Set0
// Expected file format: X8R8G8B8 or A8R8G8B8
// Used as.............: Alpha
//====================================================================
enum eTile
{
	Tile_X = 0,
	Tile_Check,
	Tile_Bullet,
	Tile_ArrowLeft,
	Tile_ArrowRight,
	Tile_ArrowUp,
	Tile_ArrowDown,
	Tile_ArrowUpDown,
	Tile_ArrowPointer,
	Tile_Arrow4Way,
	Tile_ArrowNS,
	Tile_ArrowWE,
	Tile_ArrowNESW,
	Tile_ArrowNWSE,
	Tile_Maximize,
	Tile_Restore,
	Tile_Stop,

	Tile_Count,
	Tile_Force32Bits = 0x7FFFFFFF
};


//====================================================================
VW_COMMON_API gui::TileParams __fastcall MakeTileParams(eTile t);


//====================================================================
enum
{
	Set0_NumRows  = 4,
	Set0_NumCols  = 4,
	Set0_TileSize = 32,

	// tiles
	Set0_Row_X = 0,
	Set0_Col_X = 0,

	Set0_Row_Check = 0,
	Set0_Col_Check = 1,

	Set0_Row_Bullet = 0,
	Set0_Col_Bullet = 2,

	Set0_Row_ArrowRight = 0,
	Set0_Col_ArrowRight = 3,

	Set0_Row_ArrowPointer = 1,
	Set0_Col_ArrowPointer = 0,

	Set0_Row_Arrow4Way = 1,
	Set0_Col_Arrow4Way = 1,

	Set0_Row_ArrowWE = 1,
	Set0_Col_ArrowWE = 2,

	Set0_Row_ArrowNESW = 1,
	Set0_Col_ArrowNESW = 3,

	Set0_Row_Maximize = 2,
	Set0_Col_Maximize = 0,

	Set0_Row_Restore = 2,
	Set0_Col_Restore = 1,

	Set0_Row_ArrowUpDown = 2,
	Set0_Col_ArrowUpDown = 2,

	Set0_Row_Stop = 2,
	Set0_Col_Stop = 3
};


//********************************************************************
}//namespace std_tile_textures


//********************************************************************
namespace std_fonts {


//====================================================================
VW_COMMON_API  VW_DECLARE_CONSTANT( char*, FontName_Default );
VW_COMMON_API  VW_DECLARE_CONSTANT( char*, SystemFont_Default );

VW_COMMON_API  VW_DECLARE_CONSTANT( char*, FontName_Console );
VW_COMMON_API  VW_DECLARE_CONSTANT( char*, SystemFont_Console );


//====================================================================
VW_COMMON_API
void __fastcall RegisterFont_Default(std::ostream& os,
						bool bAsciiSubsetOnly = true,
						uint textureWidth = 512,
						bool bMultiLevel = false,
						const std::string& registerUnderName = FontName_Default);


//====================================================================
VW_COMMON_API
void __fastcall RegisterFont_Console(std::ostream& os,
						bool bAsciiSubsetOnly = true,
						uint textureWidth = 512,
						bool bMultiLevel = false,
 						const std::string& registerUnderName = FontName_Console);


//********************************************************************
}//namespace std_fonts


//********************************************************************
namespace std_cursors {


//====================================================================
VW_COMMON_API
void __fastcall RegisterCursors(std::ostream& os);


//********************************************************************
}//namespace std_cursors


//********************************************************************
}//namespace gui


//********************************************************************
}//namespace vertexware


