

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI\GUI_Base.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui {


//====================================================================
VW_COMMON_API
void __fastcall CalcTextSize(
						const gui::Font& font,
						const gui::TextMetricsL& tml,
						const std::vector<std::string>& textLines,
						vec2& outTextSize,
						std::vector<float>* pOutWidths = 0);


//====================================================================
VW_COMMON_API
void __fastcall DrawTextLines(
						gui::Renderer& gr, const gui::Font& font,
						color4b textColor, const vec2& offsetTopLeft,
						const TextMetricsL& tml,
						const std::vector<std::string>& textLines);


//====================================================================
VW_COMMON_API
void __fastcall CalcPointsFromSizeAndTopLeft(
						const vec2& size, const vec2& topLeft,
						vec2& topRight, vec2& bottomLeft, vec2& bottomRight);


//********************************************************************
}//namespace gui


//********************************************************************
}//namespace vertexware


