

//--------------------------------------------------------------------
#include "MathTools\VectorBase.h"


//====================================================================
#define  ORTHOGONAL_PARALLEL_TOLERANCE_ANGLE    (1e-4)
#define  ORTHOGONAL_TEST_DEFAULT_MAX_COS_ANGLE  (CosDeg(90.0 - ORTHOGONAL_PARALLEL_TOLERANCE_ANGLE))
#define  PARALLEL_TEST_DEFAULT_MIN_COS_ANGLE    (CosDeg(ORTHOGONAL_PARALLEL_TOLERANCE_ANGLE))


//********************************************************************
namespace vertexware {


//********************************************************************
namespace math_constants {


//====================================================================
VW_DEFINE_CONSTANT( float, VectorEqualTestDefaultToleranceRadius,
												ORTHOGONAL_PARALLEL_TOLERANCE_ANGLE );

VW_DEFINE_CONSTANT( float, VectorOrthogonalTestDefaultMaxCosAngle,
												ORTHOGONAL_TEST_DEFAULT_MAX_COS_ANGLE );

VW_DEFINE_CONSTANT( float, VectorParallelTestDefaultMinCosAngle,
												PARALLEL_TEST_DEFAULT_MIN_COS_ANGLE );

VW_DEFINE_CONSTANT( float, VectorNoiseFilterDefaultTolerance, 1e-6 );


//********************************************************************
}//namespace math_constants


//********************************************************************
}//namespace vertexware


