

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\OutputForms.h"
#include "MathTools\Vector2.h"
#include "MathTools\Vector3.h"
#include "MathTools\Vector4.h"
#include "private\vw_common_exports.h"


//********************************************************************
namespace vertexware {


//====================================================================
// Handles formatted output of vectors.
//====================================================================
class VW_COMMON_API VectorOutputForm : public NumberSequenceOutputForm
{
VW_DECLARE_NUMBER_SEQUENCE_OUTPUT_FORM( VectorOutputForm )


public:
	//----------------
	// Bind to vector.
	//----------------
	const NumberSequenceBoundOutputForm_float operator()(const vec2& v) const {
		return NumberSequenceBoundOutputForm_float(*this, v.ToPtr(), 2, 2);
	}
	const NumberSequenceBoundOutputForm_float operator()(const vec3& v) const {
		return NumberSequenceBoundOutputForm_float(*this, v.ToPtr(), 3, 3);
	}
	const NumberSequenceBoundOutputForm_float operator()(const vec4& v) const {
		return NumberSequenceBoundOutputForm_float(*this, v.ToPtr(), 4, 4);
	}
};


//====================================================================
// Outputs the vector using the current form.
//====================================================================
__forceinline std::ostream& __fastcall operator<<(std::ostream &os, const vec2& v)
{
	NumberSequenceBoundOutputForm_float
			boundForm(VectorOutputForm::GetCurrentOutputForm(), v.ToPtr(), 2, 2);
	return os << boundForm;
}


//====================================================================
__forceinline std::ostream& __fastcall operator<<(std::ostream &os, const vec3& v)
{
	NumberSequenceBoundOutputForm_float
			boundForm(VectorOutputForm::GetCurrentOutputForm(), v.ToPtr(), 3, 3);
	return os << boundForm;
}


//====================================================================
__forceinline std::ostream& __fastcall operator<<(std::ostream &os, const vec4& v)
{
	NumberSequenceBoundOutputForm_float
			boundForm(VectorOutputForm::GetCurrentOutputForm(), v.ToPtr(), 4, 4);
	return os << boundForm;
}


//********************************************************************
}//namespace vertexware

