

//--------------------------------------------------------------------
#include "D3D8Tools\ErrorHandling.h"
#include "Framework\LibWrapperDXErr8.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace d3d8_tools {


//====================================================================
std::string __fastcall FormatD3DError(HRESULT hr,
								const std::string& methodName,
								const std::string& testPointName)
{
	std::string s("Direct3D8 ");
	s.append(methodName).append(" failed with code: ");
	s.append(LibWrapperDXErr8::DXGetErrorDescription8(hr));

	if(testPointName.length()) {
		s.append(" @ ").append(testPointName);
	}
	return s;
}


//====================================================================
bool __fastcall D3DErrorCheck(HRESULT hr,
								const std::string& methodName,
								const std::string& testPointName,
								std::string* pOutErrDesc)
{
	if(hr == D3D_OK) return false;
	if(pOutErrDesc) *pOutErrDesc = FormatD3DError(hr, methodName, testPointName);
	return true;
}


//====================================================================
void __fastcall D3DErrorCheckE(HRESULT hr,
								const std::string& methodName,
								const std::string& testPointName)
{
	if(hr != D3D_OK) {
		VW_THROW(D3D8Exception, FormatD3DError(hr, methodName, testPointName));
	}
}


//********************************************************************
}//namespace d3d8_tools


//********************************************************************
}//namespace vertexware


