

//--------------------------------------------------------------------
#include "D3D8Tools\Surfaces.h"
#include "BaseTools\Constructs.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace d3d8_tools {


//====================================================================
bool __fastcall CopySurfaceToImage(IDirect3DSurface8& surf, ImageBase& img)
{
#ifdef VW_BUILD_DEBUG
	D3DSURFACE_DESC surfDesc;
	surf.GetDesc(&surfDesc);
	VW_ASSERT(surfDesc.Size == img.GetTotalByteSize(), "D3DSurface/ImageBase byte-size mismatch.");
#endif

	D3DLOCKED_RECT lockedRect;
	if(surf.LockRect(&lockedRect, 0, D3DLOCK_READONLY) != D3D_OK) return false;

	ubyte* pBits = reinterpret_cast<ubyte*>(lockedRect.pBits);
	for(uint i = 0; i < img.GetNumRows(); i++) {

		::CopyMemory(img.SampleB(i, 0), pBits, img.GetRowByteSize());
		pBits += lockedRect.Pitch;
	}
	surf.UnlockRect();
	return true;
}


//********************************************************************
}//namespace d3d8_tools


//********************************************************************
}//namespace vertexware


