

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\Types.h"
#include "MathTools\Vector3.h"
#include "MathTools\Matrix44.h"
#include "private\vw_direct3d8_exports.h"
#include <d3d8.h>


//********************************************************************
namespace vertexware {


//********************************************************************
namespace d3d8_tools {


//====================================================================
// See D3DVIEWPORT8 in DX81SDK-docs
//====================================================================
VW_DIRECT3D8_API
HRESULT __fastcall Viewport(IDirect3DDevice8& device,
						uint x, uint y, uint width, uint height, float minZ, float maxZ);


//====================================================================
// D3DXMatrixPerspectiveFovLH replacement
//====================================================================
VW_DIRECT3D8_API
HRESULT __fastcall Perspective(IDirect3DDevice8& device,
						float fovYDeg, float aspectWToH, float zNear, float zFar);


//====================================================================
// Standard-RHS UVN to Direct3D-LHS UVN.
// Provide normalized-view-direction and view-position.
// Calls SetTransform(D3DTS_VIEW) internally.
//====================================================================
VW_DIRECT3D8_API
HRESULT  __fastcall View(IDirect3DDevice8& device,
						const vec3& rotation, const vec3& position = vec3::ZERO);


//====================================================================
VW_DIRECT3D8_API __forceinline
HRESULT __fastcall View(IDirect3DDevice8& device,
						float head, float pitch, float roll = 0,
						const vec3& position = vec3::ZERO)
{
	return View(device, vec3(pitch, head, roll), position);
}


//********************************************************************
}//namespace d3d8_tools


//********************************************************************
}//namespace vertexware


