

//--------------------------------------------------------------------
#include "Framework\VideoRendererDirect3D8.h"
#include "BaseTools\WinUtils.h"
#include "D3D8Tools\ErrorHandling.h"


//********************************************************************
namespace vertexware {


//====================================================================
VideoRendererDirect3D8::VideoRendererDirect3D8()
{
	pD3DVideoSubsystem = 0;

	pD3DObject = 0;
	pD3DDevice = 0;
}


//====================================================================
VideoRendererDirect3D8::~VideoRendererDirect3D8()
{
}


//====================================================================
std::string  VideoRendererDirect3D8::GetVideoRendererInterfaceName()
{
	return VW_INTERFACE_NAME_VideoRendererDirect3D8;
}


//====================================================================
std::string  VideoRendererDirect3D8::GetMatchingVideoSubsystemInterfaceName()
{
	return VW_INTERFACE_NAME_VideoSubsystemDirect3D8;
}


//====================================================================
void  VideoRendererDirect3D8::ConnectVideoSubsystem(VideoSubsystem& vs)
{
	VideoRenderer::ConnectVideoSubsystem(vs);

	pD3DVideoSubsystem = InterfaceCast<VideoSubsystemDirect3D8>(&vs);

	if(pD3DVideoSubsystem) {
		pD3DObject = pD3DVideoSubsystem->GetD3DObject();
		pD3DDevice = pD3DVideoSubsystem->GetD3DDevice();
	}
}


//====================================================================
void  VideoRendererDirect3D8::DisconnectVideoSubsystem()
{
	pD3DObject = 0;
	pD3DDevice = 0;

	pD3DVideoSubsystem = 0;

	VideoRenderer::DisconnectVideoSubsystem();
}


//====================================================================
void  VideoRendererDirect3D8::CreateVideoResources(bool bPostReset)
{
	VideoRenderer::CreateVideoResources(bPostReset);
}


//====================================================================
void  VideoRendererDirect3D8::ReleaseVideoResources(bool bPreReset)
{
	VideoRenderer::ReleaseVideoResources(bPreReset);
}


//********************************************************************
}//namespace vertexware


