

//--------------------------------------------------------------------
#include "GUI_CS0\CheckBox.h"
#include "GUI\GUI_Manager.h"
#include "GUI_CS0\ShaderNames.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_cs0 {


//====================================================================
CheckBox::GeomParams::GeomParams()
{
	preferredSize = vec2(20, 20);
}


//====================================================================
CheckBox::CheckBox(gui::Component* _parent,
					gui::MessageHandler* _commandTarget,
					uint _commandID)
	:
	Button(_parent, _commandTarget, _commandID, Style_OnOff, 0)
{
	SetShaderName(DefaultShaderName(Shader_CheckBox));
	SetGeomParams();
}


//====================================================================
void  CheckBox::SetGeomParams(const GeomParams& gp)
{
	geomParams = gp;
	ReportDirtyGeometry();
}


//====================================================================
void  CheckBox::RecalcSize()
{
	SetSize(geomParams.preferredSize);
}


//====================================================================
bool  CheckBox::OnMsgSendCommand()
{
	SetOn(! IsOn());
	SendCommandMessageToTarget();
	return true;
}


//********************************************************************
}//namespace gui_cs0


//********************************************************************
}//namespace vertexware


