

//--------------------------------------------------------------------
#include "GUI_CS0\RadioButton.h"
#include "GUI_CS0\ShaderNames.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_cs0 {


//====================================================================
RadioButton::GeomParams::GeomParams()
{
	preferredSize = vec2(20, 20);
}


//====================================================================
RadioButton::RadioButton(gui::Component* _parent,
						gui::MessageHandler* _commandTarget,
						uint _commandID,
						uint _groupID)
	:
	Button(_parent, _commandTarget, _commandID, Style_Selection, _groupID)
{
	SetShaderName(DefaultShaderName(Shader_RadioButton));
	SetGeomParams();
}


//====================================================================
void  RadioButton::SetGeomParams(const GeomParams& gp)
{
	geomParams = gp;
	ReportDirtyGeometry();
}


//====================================================================
void  RadioButton::RecalcSize()
{
	SetSize(geomParams.preferredSize);
}


//====================================================================
bool  RadioButton::OnMsgSendCommand()
{
	Select(true);
	return true;
}


//********************************************************************
}//namespace gui_cs0


//********************************************************************
}//namespace vertexware


