

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI\GUI_BehaviorBases.h"
#include "GUI\GUI_Shader.h"
#include "private\vw_gui_cs0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_cs0 {


//====================================================================
class VW_GUI_CS0_API RadioButton : public gui::Button
{
	VW_GUI_COMPONENT_DECLARE_SHADER_DLL(VW_GUI_CS0_API, Shader);
	VW_GUI_COMPONENT_DECLARE_CHECK_SHADER(Shader);


public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_CS0_API GeomParams
	{
		vec2  preferredSize;

		GeomParams();
	};


public:
	//-----------------------
	// RadioButton interface.
	//-----------------------
	RadioButton(gui::Component* parent = 0,
				gui::MessageHandler* commandTarget = 0,
				uint commandID = 0,
				uint groupID = 0);

	void               SetGeomParams(const GeomParams& gp = GeomParams());
	const GeomParams&  GetGeomParams() const { return geomParams; }


protected:
	//---------------------
	// Component overrides.
	//---------------------
	virtual  void  RecalcSize();
	virtual  bool  OnMsgSendCommand();


protected:
	//------------
	// Properties.
	//------------
	GeomParams  geomParams;
};


//********************************************************************
}//namespace gui_cs0


//********************************************************************
}//namespace vertexware


