

//--------------------------------------------------------------------
#include "GUI_CS0\ShaderNames.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_cs0 {


//====================================================================
std::string __fastcall DefaultShaderName(eShader s)
{
	switch(s) {
	case Shader_Dummy: return "cs0/Dummy";

	case Shader_Label_Static: return "cs0/Label.Static";
	case Shader_Label_Active: return "cs0/Label.Active";
	case Shader_Label_Link: return "cs0/Label.Link";

	case Shader_TextButton_Press: return "cs0/TextButton.Press";
	case Shader_TextButton_Push: return "cs0/TextButton.Push";
	case Shader_TextButton_Toggle: return "cs0/TextButton.Toggle";

	case Shader_IconButton_Press: return "cs0/IconButton.Press";
	case Shader_IconButton_Push: return "cs0/IconButton.Push";
	case Shader_IconButton_Toggle: return "cs0/IconButton.Toggle";

	case Shader_CheckBox: return "cs0/CheckBox";
	case Shader_RadioButton: return "cs0/RadioButton";
	case Shader_EditBox: return "cs0/EditBox";
	case Shader_ComboBox: return "cs0/ComboBox";
	case Shader_ScrollBar: return "cs0/ScrollBar";
	case Shader_HorzSeparator: return "cs0/HorzSeparator";
	case Shader_HorzTextSeparator: return "cs0/HorzTextSeparator";
	case Shader_ControlGroupFrame: return "cs0/ControlGroupFrame";
	case Shader_LogoSpinner: return "cs0/LogoSpinner";
	case Shader_ToolTip: return "cs0/ToolTip";
	case Shader_RubberBand: return "cs0/RubberBand";

	case Shader_MenuBar: return "cs0/MenuBar";
	case Shader_MenuBar_IconButton_BarControl: return "cs0/MenuBar/IconButton.BarControl";
	case Shader_MenuTitle: return "cs0/MenuTitle";
	case Shader_MenuPane: return "cs0/MenuPane";
	case Shader_MenuSeparator: return "cs0/MenuSeparator";
	case Shader_MenuItem: return "cs0/MenuItem";

	case Shader_PixelOffsetControlPane: return "cs0/PixelOffsetControlPane";
	case Shader_PixelOffsetControlPane_IconButton: return "cs0/PixelOffsetControlPane/IconButton";
	case Shader_PixelOffsetControlPane_Label: return "cs0/PixelOffsetControlPane/Label";

	case Shader_PropertyTab: return "cs0/PropertyTab";
	case Shader_PropertyPage: return "cs0/PropertyPage";

	case Shader_Console_OutputBgr: return "cs0/Console/OutputBgr";
	case Shader_Console_EditBox: return "cs0/Console/EditBox";
	case Shader_Console_ScrollBar: return "cs0/Console/ScrollBar";

	case Shader_TopLevelFrame: return "cs0/TopLevelFrame";
	case Shader_TopLevelFrame_IconButton_FrameControl_Push: return "cs0/TopLevelFrame/IconButton.FrameControl.Push";
	case Shader_TopLevelFrame_IconButton_FrameControl_Toggle: return "cs0/TopLevelFrame/IconButton.FrameControl.Toggle";
	case Shader_TopLevelFrame_TextButton_FrameControl_Push: return "cs0/TopLevelFrame/TextButton.FrameControl.Push";
	case Shader_TopLevelFrame_TextButton_FrameControl_Toggle: return "cs0/TopLevelFrame/TextButton.FrameControl.Toggle";

	case Shader_TopLevelPane: return "cs0/TopLevelPane";
	case Shader_TopLevelPane_IconButton_PaneControl: return "cs0/TopLevelPane/IconButton.PaneControl";

	case Shader_Overlay_Label_Static: return "cs0/Overlay/Label.Static";
	case Shader_Overlay_TextButton_Press: return "cs0/Overlay/TextButton.Press";
	case Shader_Overlay_TextButton_Push: return "cs0/Overlay/TextButton.Push";
	case Shader_Overlay_TextButton_Toggle: return "cs0/Overlay/TextButton.Toggle";
	case Shader_Overlay_IconButton_Press: return "cs0/Overlay/IconButton.Press";
	case Shader_Overlay_IconButton_Push: return "cs0/Overlay/IconButton.Push";
	case Shader_Overlay_IconButton_Toggle: return "cs0/Overlay/IconButton.Toggle";
	case Shader_Overlay_CheckBox: return "cs0/Overlay/CheckBox";
	}
	return "";
}


//********************************************************************
}//namespace gui_cs0


//********************************************************************
}//namespace vertexware


