

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI\GUI_Layouters.h"
#include "GUI_CS0\TopLevelFrame.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_cs0 {


//====================================================================
class VW_GUI_CS0_API ToolBar : public gui_cs0::TopLevelFrame
{
public:
	//-------------------------------------------------------------
	typedef  gui::layouters::ArrayLayouter::GeomParams  GeomParams;

	enum { DefaultSpacerLength = gui::layouters::Spacer::DefaultLength };

	//-------------------
	// ToolBar interface.
	//-------------------
	ToolBar(const std::string& title = "ToolBar", bool bVertical = true);

	void               SetGeomParams(const GeomParams& gp = GeomParams());
	const GeomParams&  GetGeomParams() const;

	void  AttachControl(gui::Component* c);
	void  DetachControl(gui::Component* c);
	void  DetachAllControls();
	void  DeleteAllControls();

	void  ClearSpacers();
	void  AddSpacer(const gui::Component* pBefore = 0, float length = DefaultSpacerLength);
	void  RemoveSpacer(const gui::Component* pBefore = 0);


protected:
	//---------------------
	// Component overrides.
	//---------------------
	virtual  bool  OnCommand(uint commandID);
	virtual  void  RecalcLayout();

	//--------------------------------
	// Derived-class template-methods.
	//--------------------------------
	virtual  bool  ProcessToolBarControlCommand(uint commandID) { return false; }


protected:
	//----------------
	// Sub-components.
	//----------------
	gui::layouters::ArrayLayouter*  pLayouter;
};


//********************************************************************
}//namespace gui_cs0


//********************************************************************
}//namespace vertexware


