

//--------------------------------------------------------------------
#include "GUI_SS0\Console.h"
#include "GUI\GUI_Manager.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
CS0_ConsoleOutputBgrShader::ShaderParams::ShaderParams()
{
	colorBgrTop = color4b(64, 128, 128);
	colorBgrBottom = color4b(0, 0, 0);
	colorBorder = color4b::BLACK;
	borderWidth = 1;
}


//====================================================================
CS0_ConsoleOutputBgrShader::CS0_ConsoleOutputBgrShader(const std::string& shaderName,
														const ShaderParams& sp)
	:
	gui_cs0::Console::OutputBgrShader(shaderName),
	shaderParams(sp)
{
}


//====================================================================
void  CS0_ConsoleOutputBgrShader::Shade(const gui::Component& c, gui::Renderer& gr) const
{
	const gui_cs0::Console& console = gui::ComponentCast<gui_cs0::Console>(c);

	gui::RectangleC r;

	// draw background
	console.GetOutputTextAreaRectangle(r);
	r.SetColorTop(shaderParams.colorBgrTop);
	r.SetColorBottom(shaderParams.colorBgrBottom);

	gr.DrawRectangle(r);

	// draw border
	if(shaderParams.borderWidth) {

		r.SetColor(shaderParams.colorBorder);
		gr.DrawRectangleFrame(r, shaderParams.borderWidth);
	}
}


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


