

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\Console.h"
#include "GUI_SS0\Buttons.h"
#include "GUI_SS0\EditBox.h"
#include "GUI_SS0\ScrollBar.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_ConsoleOutputBgrShader : public gui_cs0::Console::OutputBgrShader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorBgrTop;
		color4b  colorBgrBottom;
		color4b  colorBorder;
		float    borderWidth;

		ShaderParams();
	};


public:
	//--------------------------------------
	// CS0_ConsoleOutputBgrShader interface.
	//--------------------------------------
	CS0_ConsoleOutputBgrShader(const std::string& shaderName = "",
								const ShaderParams& sp = ShaderParams());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


