

//--------------------------------------------------------------------
#include "GUI_SS0\PixelOffsetControlPane.h"
#include "GUI_SS0\Buttons.h"
#include "GUI_SS0\Label.h"
#include "GUI\GUI_Manager.h"
#include "GUI\GUI_Tools.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
CS0_PixelOffsetControlPaneShader::ShaderParams::ShaderParams()
{
	colorScreenBorder = color4b::WHITE;
	colorControlArea = color4b(61, 149, 255);
}


//====================================================================
CS0_PixelOffsetControlPaneShader::CS0_PixelOffsetControlPaneShader(
					const std::string& shaderName, const ShaderParams& sp)
	:
	gui_cs0::PixelOffsetControlPane::Shader(shaderName)
{
	SetShaderParams(sp);
}


//====================================================================
void  CS0_PixelOffsetControlPaneShader::SetShaderParams(const ShaderParams& sp)
{
	shaderParams = sp;

	rControlArea.SetColor(sp.colorControlArea);
	rBorderLeft.SetColor(sp.colorScreenBorder);
	rBorderRight.SetColor(sp.colorScreenBorder);
	rBorderTop.SetColor(sp.colorScreenBorder);
	rBorderBottom.SetColor(sp.colorScreenBorder);
}


//====================================================================
void  CS0_PixelOffsetControlPaneShader::Shade(const gui::Component& c, gui::Renderer& gr) const
{
	const gui_cs0::PixelOffsetControlPane& pane = gui::ComponentCast<gui_cs0::PixelOffsetControlPane>(c);

	pane.GetDrawRectangles(rControlArea, rBorderLeft, rBorderRight, rBorderTop, rBorderBottom);

	gr.DrawRectangle(rControlArea);
	gr.DrawRectangle(rBorderLeft);
	gr.DrawRectangle(rBorderRight);
	gr.DrawRectangle(rBorderTop);
	gr.DrawRectangle(rBorderBottom);
}


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


