

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\PropertyFrame.h"
#include "GUI_SS0\Label.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_PropertyTabShader : public gui_cs0::PropertyTab::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorBgrTop;
		color4b  colorBgrBottom;
		color4b  colorBgrTopHotSelected;
		color4b  colorBgrBottomHotSelected;
		color4b  colorBorder;
		float    borderWidth;
		color4b  colorHiliteTop;
		color4b  colorHiliteBottom;
		float    hiliteWidth;
		color4b  colorText;
		color4b  colorTextSelected;
		color4b  colorTextHot;

		ShaderParams();

		void  ChooseParams(const gui_cs0::PropertyTab& tab,
						color4b& cBgrTop, color4b& cBgrBottom) const;
	};


public:
	//---------------------------------
	// CS0_PropertyTabShader interface.
	//---------------------------------
	CS0_PropertyTabShader(const std::string& shaderName = "",
						const ShaderParams& sp = ShaderParams(),
						const gui::TextAttributes& ta = DefaultTextAttributes());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//====================================================================
class VW_GUI_SS0_API CS0_PropertyPageShader : public gui_cs0::PropertyPage::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorBgrTop;
		color4b  colorBgrBottom;
		color4b  colorBorder;
		float    borderWidth;

		ShaderParams();
	};


public:
	//----------------------------------
	// CS0_PropertyPageShader interface.
	//----------------------------------
	CS0_PropertyPageShader(const std::string& shaderName = "",
							const ShaderParams& sp = ShaderParams());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


