

//--------------------------------------------------------------------
#include "GUI_SS0\RubberBand.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
CS0_RubberbandShader::ShaderParams::ShaderParams()
{
	colorArea = color4b(0, 128, 160, 128);
	colorBorder = color4b(0, 0, 128, 192);
	borderWidth = 2;
}


//====================================================================
CS0_RubberbandShader::CS0_RubberbandShader(const std::string& shaderName,
											const ShaderParams& sp)
	:
	gui_cs0::Rubberband::Shader(shaderName),
	shaderParams(sp)
{
}


//====================================================================
void  CS0_RubberbandShader::Shade(const gui::Component& c, gui::Renderer& gr) const
{
	const gui_cs0::Rubberband& rubberBand = gui::ComponentCast<gui_cs0::Rubberband>(c);

	gui::RectangleC r;
	rubberBand.GetLastArea(r);

	r.SetColor(shaderParams.colorArea);
	gr.DrawRectangle(r);

	if(shaderParams.borderWidth) {
		r.SetColor(shaderParams.colorBorder);
		gr.DrawRectangleFrame(r, shaderParams.borderWidth);
	}
}


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


