

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\ToolTip.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_ToolTipShader : public gui_cs0::ToolTip::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorBorder;
		color4b  colorBgr;
		color4b  colorText;
		float    borderWidth;

		ShaderParams();
	};

	//------------------------------------------------------------
	static gui::TextAttributes __fastcall DefaultTextAttributes();


public:
	//-----------------------------
	// CS0_ToolTipShader interface.
	//-----------------------------
	CS0_ToolTipShader(const std::string& shaderName = "",
					const ShaderParams& sp = ShaderParams(),
					const gui::TextAttributes& ta = DefaultTextAttributes());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


