

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\TopLevelFrame.h"
#include "GUI_SS0\Buttons.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_TopLevelFrameShader : public gui_cs0::TopLevelFrame::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorMainArea1;
		color4b  colorMainArea2;
		color4b  colorTitleBar1;
		color4b  colorTitleBar2;
		color4b  colorTitleBarActive1;
		color4b  colorTitleBarActive2;
		color4b  colorTitleText;
		color4b  colorTitleTextActive;

		ShaderParams();
	};


public:
	//-----------------------------------
	// CS0_TopLevelFrameShader interface.
	//-----------------------------------
	CS0_TopLevelFrameShader(const std::string& shaderName = "",
						const ShaderParams& sp = ShaderParams(),
						const gui::TextAttributes ta = DefaultTextAttributes());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


