

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "GUI_CS0\TopLevelPane.h"
#include "GUI_SS0\Buttons.h"
#include "private\vw_gui_ss0_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gui_ss0 {


//====================================================================
class VW_GUI_SS0_API CS0_TopLevelPaneShader : public gui_cs0::TopLevelPane::Shader
{
public:
	//----------------
	// Parameter sets.
	//----------------
	struct VW_GUI_SS0_API ShaderParams
	{
		color4b  colorBgr;
		color4b  colorBgrActive;
		color4b  colorBgrHot;
		color4b  colorTitle;
		color4b  colorTitleActive;
		color4b  colorTitleHot;

		ShaderParams();

		void  ChooseParams(const gui_cs0::TopLevelPane& tlp,
							color4b& cBgr, color4b& cTitle) const;
	};


public:
	//----------------------------------
	// CS0_TopLevelPaneShader interface.
	//----------------------------------
	CS0_TopLevelPaneShader(const std::string& shaderName = "",
						const ShaderParams& sp = ShaderParams(),
						const gui::TextAttributes ta = DefaultTextAttributes());

	void                 SetShaderParams(const ShaderParams& sp = ShaderParams()) { shaderParams = sp; }
	const ShaderParams&  GetShaderParams() const { return shaderParams; }

	//---------------------------
	// BaseShader implementation.
	//---------------------------
	virtual  void  Shade(const gui::Component& c, gui::Renderer& gr) const;


protected:
	//------------
	// Properties.
	//------------
	ShaderParams  shaderParams;
};


//********************************************************************
}//namespace gui_ss0


//********************************************************************
}//namespace vertexware


