

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "Framework\FrameworkCommands.h"
#include "Framework\VideoRendererOpenGL.h"
#include "private\vw_opengl_exports.h"


//********************************************************************
namespace vertexware {


//********************************************************************
namespace framework_commands_opengl {


//====================================================================
VW_OPENGL_API
void __fastcall CreateAndRegisterAllCommands(
								std_command_interpreter::Interpreter& ci);


//====================================================================
class VW_OPENGL_API VROpenGLCmd : public Command
{
public:
	static const char* s_szDefaultName;
	static const char* s_szOptionDumpDriverInfoAll;
	static const char* s_szOptionDumpDriverInfoVendor;
	static const char* s_szOptionDumpDriverInfoExtensions;
	static const char* s_szOptionDumpDriverInfoAdditional;
	static const char* s_szOptionRefreshExtensionPointers;
	static const char* s_szOptionEnableAllExtensions;
	static const char* s_szOptionDisableAllExtensions;
	static const char* s_szAssignEnableExtensions;
	static const char* s_szAssignDisableExtensions;


public:
	VROpenGLCmd();

	virtual  bool  ParseAndExecute(std::ostream& os, const CommandLineParser& clp,
									const std::string& rawCommandLine);

	virtual  void  DumpHelp(std::ostream& os, const CommandLineParser& clp);


private:
	void  EnableExtensions(VideoRendererOpenGL& vr, bool bEnable,
							const std::vector<std::string>& extNameList);
};


//********************************************************************
}//namespace framework_commands_opengl


//********************************************************************
}//namespace vertexware


