

//--------------------------------------------------------------------
#pragma once


//--------------------------------------------------------------------
#include "BaseTools\Types.h"
#include "private\vw_opengl_exports.h"
#include <gl\gl.h>


//********************************************************************
namespace vertexware {


//********************************************************************
namespace gl_tools {


//====================================================================
class VW_OPENGL_API DisplayList
{
public:
	DisplayList();
	~DisplayList();

	GLuint  GetName() const { return name; }

	void  Execute() const { glCallList(name); }


private:
	GLuint  name;
};


//====================================================================
class VW_OPENGL_API DisplayListCompileSentry
{
public:
	DisplayListCompileSentry(DisplayList& dl) {
		glNewList(dl.GetName(), GL_COMPILE);
	}
	~DisplayListCompileSentry() {
		glEndList();
	}
};


//********************************************************************
}//namespace gl_tools


//********************************************************************
}//namespace vertexware


